game
.L00 ;  rem =====================================================================

.L01 ;  rem 

.L02 ;  rem    Snappy - an Atari 2600 game by Sebastian Mihai (2012)

.L03 ;  rem 

.L04 ;  rem    http://sebastianmihai.com (site was operational in 2012)

.L05 ;  rem

.L06 ;  rem    The code should be easy enough to follow, and I think it makes a

.L07 ;  rem    great starting point for developers wishing to program the Atari

.L08 ;  rem    2600. If you have any questions regarding why a certain thing is

.L09 ;  rem    done a certain way, please contact me through the method

.L010 ;  rem    mentioned on the home page of the website.

.L011 ;  rem 

.L012 ;  rem =====================================================================

.
 ; 

.L013 ;  rem BATARI DEFINES VARIABLES WITH NAMES FROM A TO Z

.L014 ;  rem THE STATEMENTS BELOW SIMPLY RENAME THE VARIABLES WITH MORE MEANINGFUL NAMES

.L015 ;  dim frame  =  d

.L016 ;  dim playerframe  =  e

.L017 ;  dim gamestate  =  f

.L018 ;  dim snappyframe  =  g

.L019 ;  dim introcolour  =  h

.L020 ;  dim snappyeatingframe  =  i

.L021 ;  dim life  =  j

.L022 ;  dim randseed  =  k

.
 ; 

.L023 ;  rem FRAME MOVES BETWEEN 0 AND 119

.L024 ;  rem VINE POSITION IS BASED ON IT

.L025 ;  frame  =  30

	LDA #30
	STA frame
.
 ; 

.L026 ;  rem USED TO SEED RANDOM NUMBER SEQUENCE WHILE WAITING FOR PLAYER TO START GAME

.L027 ;  randseed  =  0

	LDA #0
	STA randseed
.
 ; 

.L028 ;  rem PLAYERFRAME CONTROLS PLAYER ANIMATION

.L029 ;  playerframe  =  0

	LDA #0
	STA playerframe
.
 ; 

.L030 ;  rem ========= GAMESTATE VALUES ========

.L031 ;  rem 1 PLAYER DROPPING

.L032 ;  rem 2 PLAYER WAITING

.L033 ;  rem 3 PLAYER MOVING TOWARDS PIT

.L034 ;  rem 4 PLAYER HOLDING ON TO VINE

.L035 ;  rem 5 PLAYER MOVING TO GOAL

.L036 ;  rem 6 PLAYER SAFE

.L037 ;  rem 7 PLAYER DYING

.L038 ;  rem 8 SNAPPY EATING

.L039 ;  rem ====================================

.L040 ;  gamestate  =  6

	LDA #6
	STA gamestate
.
 ; 

.L041 ;  rem SCORE IS DISPLAYED IN THIS COLOUR

.L042 ;  scorecolor  =  22

	LDA #22
	STA scorecolor
.
 ; 

.L043 ;  rem INITIAL TITLE SCREEN COLOUR

.L044 ;  introcolour  =  0

	LDA #0
	STA introcolour
.
 ; 

.L045 ;  goto main

 jmp .main

.
 ; 

.L046 ;  rem =================================

.L047 ;  rem ====== SHOW INTRO AND WAIT ======

.L048 ;  rem =================================

.showintro
 ; showintro

.L049 ;  playfield:

  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel0
PF_data0
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %00011100, %00000000, %00000000, %00000000
	.byte %00100010, %00000000, %00000000, %00000000
	.byte %00100000, %00000000, %00000000, %00000000
	.byte %00011100, %11100011, %00110011, %00100100
	.byte %00000010, %10010101, %00101010, %00100101
	.byte %00100010, %10010101, %00101010, %00100101
	.byte %00011100, %01100101, %10110011, %00111000
	.byte %00000000, %00000000, %00100010, %00100000
	.byte %00000000, %00000000, %00100010, %00011000
	.byte %00000000, %00000000, %00000000, %00000000
pflabel0
	lda PF_data0,x
	sta playfield,x
	dex
	bpl pflabel0
.
 ; 

.L050 ;  introcolour  =  introcolour  +  1

	INC introcolour
.L051 ;  COLUPF  =  introcolour

	LDA introcolour
	STA COLUPF
.L052 ;  COLUBK  =  0

	LDA #0
	STA COLUBK
.L053 ;  COLUP0  =  0

	LDA #0
	STA COLUP0
.L054 ;  COLUP1  =  0

	LDA #0
	STA COLUP1
.L055 ;  player0x  =  0

	LDA #0
	STA player0x
.L056 ;  player0y  =  0

	LDA #0
	STA player0y
.L057 ;  player1x  =  0

	LDA #0
	STA player1x
.L058 ;  player1y  =  0

	LDA #0
	STA player1y
.L059 ;  randseed  =  randseed  +  1

 jsr randomize
	CLC
	ADC #1
	STA randseed
.L060 ;  gosub stopvoiceone

 jsr .stopvoiceone

.L061 ;  gosub stopvoicezero

 jsr .stopvoicezero

.L062 ;  drawscreen

 jsr drawscreen
.L063 ;  if joy0fire then goto initialize

 lda #$80
 bit INPT4
	BNE .skipL063
.condpart0
 jmp .initialize

.skipL063
.L064 ;  goto showintro

 jmp .showintro

.
 ; 

.L065 ;  rem =================================

.L066 ;  rem ====== INITIALIZE GAME ==========

.L067 ;  rem =================================

.initialize
 ; initialize

.L068 ;  score  =  0

	LDA #$00
	STA score+2
	LDA #$00
	STA score+1
	LDA #$00
	STA score
.L069 ;  life  =  10

	LDA #10
	STA life
.L070 ;  if randseed  =  0 then rand  =  1 else rand  =  randseed

	LDA randseed
	CMP #0
     BNE .skipL070
.condpart1
	LDA #1
	STA rand
 jmp .skipelse0
.skipL070
 jsr randomize
	STA rand
.skipelse0
.L071 ;  goto main

 jmp .main

.
 ; 

.L072 ;  rem ===================================================

.L073 ;  rem =============== ANIMATE SNAPPY ====================

.L074 ;  rem ===================================================

.animatesnappy
 ; animatesnappy

.L075 ;  if snappyframe  =  0 then player1:

	LDA snappyframe
	CMP #0
     BNE .skipL075
.condpart2
	LDA #<player2then_1

	STA player1pointerlo
	LDA #>player2then_1

	STA player1pointerhi
	LDA #11
	STA player1height
.skipL075
.L076 ;  if snappyframe  =  10 then player1:

	LDA snappyframe
	CMP #10
     BNE .skipL076
.condpart3
	LDA #<player3then_1

	STA player1pointerlo
	LDA #>player3then_1

	STA player1pointerhi
	LDA #11
	STA player1height
.skipL076
.L077 ;  return

	RTS
.
 ; 

.L078 ;  rem ===================================================

.L079 ;  rem =============== VINE ANIMATION ====================

.L080 ;  rem ===================================================

.swingvine
 ; swingvine

.
 ; 

.L081 ;  if frame  =  0 then playfield:

	LDA frame
	CMP #0
     BNE .skipL081
.condpart4
  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel1
PF_data1
	.byte %00000000, %00000000, %00111111, %00000111
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000100, %00000000
	.byte %00000000, %00000000, %00001000, %00000000
	.byte %00000000, %00000000, %00010000, %00000000
	.byte %00000000, %00000000, %00100000, %00000000
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11111111, %11111111
pflabel1
	lda PF_data1,x
	sta playfield,x
	dex
	bpl pflabel1
.skipL081
.L082 ;  if frame  =  10  ||  frame  =  110 then playfield:

	LDA frame
	CMP #10
     BNE .skipL082
.condpart5
 jmp .condpart6
.skipL082
	LDA frame
	CMP #110
     BNE .skip0OR
.condpart6
  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel2
PF_data2
	.byte %00000000, %00000000, %00111111, %00000111
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000100, %00000000
	.byte %00000000, %00000000, %00000100, %00000000
	.byte %00000000, %00000000, %00001000, %00000000
	.byte %00000000, %00000000, %00010000, %00000000
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11111111, %11111111
pflabel2
	lda PF_data2,x
	sta playfield,x
	dex
	bpl pflabel2
.skip0OR
.L083 ;  if frame  =  20  ||  frame  =  100 then playfield:

	LDA frame
	CMP #20
     BNE .skipL083
.condpart7
 jmp .condpart8
.skipL083
	LDA frame
	CMP #100
     BNE .skip1OR
.condpart8
  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel3
PF_data3
	.byte %00000000, %00000000, %00111111, %00000111
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000100, %00000000
	.byte %00000000, %00000000, %00000100, %00000000
	.byte %00000000, %00000000, %00000100, %00000000
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11111111, %11111111
pflabel3
	lda PF_data3,x
	sta playfield,x
	dex
	bpl pflabel3
.skip1OR
.L084 ;  if frame  =  30  ||  frame  =  90 then playfield:

	LDA frame
	CMP #30
     BNE .skipL084
.condpart9
 jmp .condpart10
.skipL084
	LDA frame
	CMP #90
     BNE .skip2OR
.condpart10
  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel4
PF_data4
	.byte %00000000, %00000000, %00111111, %00000111
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11111111, %11111111
pflabel4
	lda PF_data4,x
	sta playfield,x
	dex
	bpl pflabel4
.skip2OR
.L085 ;  if frame  =  40  ||  frame  =  80 then playfield:

	LDA frame
	CMP #40
     BNE .skipL085
.condpart11
 jmp .condpart12
.skipL085
	LDA frame
	CMP #80
     BNE .skip3OR
.condpart12
  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel5
PF_data5
	.byte %00000000, %00000000, %00111111, %00000111
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000001, %00000000
	.byte %00000000, %00000000, %00000001, %00000000
	.byte %00000000, %00000000, %00000001, %00000000
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11111111, %11111111
pflabel5
	lda PF_data5,x
	sta playfield,x
	dex
	bpl pflabel5
.skip3OR
.L086 ;  if frame  =  50  ||  frame  =  70 then playfield:

	LDA frame
	CMP #50
     BNE .skipL086
.condpart13
 jmp .condpart14
.skipL086
	LDA frame
	CMP #70
     BNE .skip4OR
.condpart14
  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel6
PF_data6
	.byte %00000000, %00000000, %00111111, %00000111
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000001, %00000000
	.byte %00000000, %00000000, %00000001, %00000000
	.byte %00000000, %00000000, %00000000, %00000001
	.byte %00000000, %00000000, %00000000, %00000010
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11111111, %11111111
pflabel6
	lda PF_data6,x
	sta playfield,x
	dex
	bpl pflabel6
.skip4OR
.L087 ;  if frame  =  60 then playfield:

	LDA frame
	CMP #60
     BNE .skipL087
.condpart15
  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel7
PF_data7
	.byte %00000000, %00000000, %00111111, %00000111
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000001, %00000000
	.byte %00000000, %00000000, %00000000, %00000001
	.byte %00000000, %00000000, %00000000, %00000010
	.byte %00000000, %00000000, %00000000, %00000100
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11111111, %11111111
pflabel7
	lda PF_data7,x
	sta playfield,x
	dex
	bpl pflabel7
.skipL087
.L088 ;  if frame  =  0 gosub playvinesound

	LDA frame
	CMP #0
	beq .playvinesound
.L089 ;  if frame  =  60 gosub playvinesecondsound

	LDA frame
	CMP #60
	beq .playvinesecondsound
.L090 ;  if frame  =  3 gosub stopvoicezero

	LDA frame
	CMP #3
	beq .stopvoicezero
.L091 ;  if frame  =  63 gosub stopvoicezero

	LDA frame
	CMP #63
	beq .stopvoicezero
.L092 ;  return

	RTS
.
 ; 

.L093 ;  rem ===========================

.L094 ;  rem ==== SOUND ROUTINES =======

.L095 ;  rem ===========================

.playvinesound
 ; playvinesound

.L096 ;  AUDV0 = 4 : AUDC0 = 12 : AUDF0 = 28

	LDA #4
	STA AUDV0
	LDA #12
	STA AUDC0
	LDA #28
	STA AUDF0
.L097 ;  return

	RTS
.
 ; 

.playvinesecondsound
 ; playvinesecondsound

.L098 ;  AUDV0 = 4 : AUDC0 = 12 : AUDF0 = 20

	LDA #4
	STA AUDV0
	LDA #12
	STA AUDC0
	LDA #20
	STA AUDF0
.L099 ;  return

	RTS
.
 ; 

.playdeathsound
 ; playdeathsound

.L0100 ;  AUDV1 = 4 : AUDC1 = 14 : AUDF1 = 20

	LDA #4
	STA AUDV1
	LDA #14
	STA AUDC1
	LDA #20
	STA AUDF1
.L0101 ;  return

	RTS
.
 ; 

.playvictorysound
 ; playvictorysound

.L0102 ;  AUDV1 = 4 : AUDC1 = 4 : AUDF1 = 10

	LDA #4
	STA AUDV1
	STA AUDC1
	LDA #10
	STA AUDF1
.L0103 ;  return

	RTS
.
 ; 

.stopvoicezero
 ; stopvoicezero

.L0104 ;  AUDV0 = 0

	LDA #0
	STA AUDV0
.L0105 ;  return

	RTS
.
 ; 

.stopvoiceone
 ; stopvoiceone

.L0106 ;  AUDV1 = 0

	LDA #0
	STA AUDV1
.L0107 ;  return

	RTS
.
 ; 

.L0108 ;  rem ===========================================

.L0109 ;  rem =============== DRAW PLAYER ===============

.L0110 ;  rem ===========================================

.drawplayer
 ; drawplayer

.L0111 ;  if playerframe  =  0 then player0:

	LDA playerframe
	CMP #0
     BNE .skipL0111
.condpart16
	LDA #<player16then_0

	STA player0pointerlo
	LDA #>player16then_0

	STA player0pointerhi
	LDA #8
	STA player0height
.skipL0111
.L0112 ;  if playerframe  =  10 then player0:

	LDA playerframe
	CMP #10
     BNE .skipL0112
.condpart17
	LDA #<player17then_0

	STA player0pointerlo
	LDA #>player17then_0

	STA player0pointerhi
	LDA #8
	STA player0height
.skipL0112
.L0113 ;  return

	RTS
.
 ; 

.drawplayerparachute
 ; drawplayerparachute

.L0114 ;  player0:

	LDA #<playerL0114_0

	STA player0pointerlo
	LDA #>playerL0114_0

	STA player0pointerhi
	LDA #16
	STA player0height
.L0115 ;  return

	RTS
.
 ; 

.drawplayerbeingeaten
 ; drawplayerbeingeaten

.L0116 ;  player0:

	LDA #<playerL0116_0

	STA player0pointerlo
	LDA #>playerL0116_0

	STA player0pointerhi
	LDA #8
	STA player0height
.L0117 ;  return

	RTS
.
 ; 

.L0118 ;  rem =================================

.L0119 ;  rem ====== MAIN GAME LOOP ===========

.L0120 ;  rem =================================

.main
 ; main

.
 ; 

.L0121 ;  rem GAME OVER?

.L0122 ;  if life  =  0 then goto showintro

	LDA life
	CMP #0
     BNE .skipL0122
.condpart18
 jmp .showintro

.skipL0122
.
 ; 

.L0123 ;  rem SET VINE FRAME GRAPHICS

.L0124 ;  gosub swingvine

 jsr .swingvine

.
 ; 

.L0125 ;  rem SET SNAPPY FRAME GRAPHICS

.L0126 ;  gosub animatesnappy

 jsr .animatesnappy

.
 ; 

.L0127 ;  rem SET PLAYER FRAME GRAPHICS

.L0128 ;  if gamestate  =  1 then gosub drawplayerparachute

	LDA gamestate
	CMP #1
     BNE .skipL0128
.condpart19
 jsr .drawplayerparachute

.skipL0128
.L0129 ;  if gamestate  =  8 then gosub drawplayerbeingeaten

	LDA gamestate
	CMP #8
     BNE .skipL0129
.condpart20
 jsr .drawplayerbeingeaten

.skipL0129
.L0130 ;  if gamestate  <>  1  &&  gamestate  <>  8 then gosub drawplayer

	LDA gamestate
	CMP #1
     BEQ .skipL0130
.condpart21
	LDA gamestate
	CMP #8
     BEQ .skip21then
.condpart22
 jsr .drawplayer

.skip21then
.skipL0130
.
 ; 

.L0131 ;  rem ADVANCE FRAMES

.L0132 ;  frame = frame + 1

	INC frame
.L0133 ;  playerframe = playerframe + 1

	INC playerframe
.L0134 ;  snappyframe = snappyframe + 1

	INC snappyframe
.
 ; 

.L0135 ;  rem SNAPPY CHOMPS FASTER WHEN HE'S EATING THE PLAYER!!

.L0136 ;  if gamestate  =  8 then snappyframe = snappyframe + 1

	LDA gamestate
	CMP #8
     BNE .skipL0136
.condpart23
	INC snappyframe
.skipL0136
.
 ; 

.L0137 ;  rem APPLY BOUND TO FRAMES

.L0138 ;  if playerframe  >=  20 then playerframe = 0

	LDA playerframe
	CMP #20
     BCC .skipL0138
.condpart24
	LDA #0
	STA playerframe
.skipL0138
.L0139 ;  if frame >= 120 then frame = 0

	LDA frame
	CMP #120
     BCC .skipL0139
.condpart25
	LDA #0
	STA frame
.skipL0139
.L0140 ;  if snappyframe  >=  20 then snappyframe = 0

	LDA snappyframe
	CMP #20
     BCC .skipL0140
.condpart26
	LDA #0
	STA snappyframe
.skipL0140
.
 ; 

.L0141 ;  rem CALCULATE NEW PLAYER POSITION, ENFORCE GAME RULES, ETC.

.L0142 ;  gosub handlestate

 jsr .handlestate

.
 ; 

.L0143 ;  COLUP1  =  206

	LDA #206
	STA COLUP1
.L0144 ;  COLUP0  =  28

	LDA #28
	STA COLUP0
.L0145 ;  COLUBK  =  192

	LDA #192
	STA COLUBK
.L0146 ;  COLUPF  =  88

	LDA #88
	STA COLUPF
.
 ; 

.L0147 ;  rem PERFORM ACTUAL RENDERING

.L0148 ;  drawscreen

 jsr drawscreen
.
 ; 

.L0149 ;  rem BACK TO BEGINNING OF GAME LOOP

.L0150 ;  goto main

 jmp .main

.
 ; 

.L0151 ;  rem =========================================

.L0152 ;  rem = HANDLE GAME STATES BY MOVING PLAYER ===

.L0153 ;  rem = CHECKING GAME RULES AND STATE CHANGES =

.L0154 ;  rem =========================================

.handlestate
 ; handlestate

.L0155 ;  if gamestate  =  6 then gosub createplayer  :  return

	LDA gamestate
	CMP #6
     BNE .skipL0155
.condpart27
 jsr .createplayer
	RTS
.skipL0155
.L0156 ;  if gamestate  =  1 then gosub dropplayer  :  return

	LDA gamestate
	CMP #1
     BNE .skipL0156
.condpart28
 jsr .dropplayer
	RTS
.skipL0156
.L0157 ;  if gamestate  =  2 then gosub playerwaiting  :  return

	LDA gamestate
	CMP #2
     BNE .skipL0157
.condpart29
 jsr .playerwaiting
	RTS
.skipL0157
.L0158 ;  if gamestate  =  3 then gosub playerrunning  :  return

	LDA gamestate
	CMP #3
     BNE .skipL0158
.condpart30
 jsr .playerrunning
	RTS
.skipL0158
.L0159 ;  if gamestate  =  4 then gosub playeronvine  :  return

	LDA gamestate
	CMP #4
     BNE .skipL0159
.condpart31
 jsr .playeronvine
	RTS
.skipL0159
.L0160 ;  if gamestate  =  7 then gosub playerdying  :  return

	LDA gamestate
	CMP #7
     BNE .skipL0160
.condpart32
 jsr .playerdying
	RTS
.skipL0160
.L0161 ;  if gamestate  =  5 then gosub playerruntosafety  :  return

	LDA gamestate
	CMP #5
     BNE .skipL0161
.condpart33
 jsr .playerruntosafety
	RTS
.skipL0161
.L0162 ;  if gamestate  =  8 then gosub snappyeating  :  return

	LDA gamestate
	CMP #8
     BNE .skipL0162
.condpart34
 jsr .snappyeating
	RTS
.skipL0162
.L0163 ;  return

	RTS
.
 ; 

.snappyeating
 ; snappyeating

.L0164 ;  snappyeatingframe  =  snappyeatingframe  +  1

	INC snappyeatingframe
.L0165 ;  playerframe = 0

	LDA #0
	STA playerframe
.L0166 ;  if snappyeatingframe  =  60 then gosub stopvoiceone  :  gamestate  =  6  :  life = life - 1

	LDA snappyeatingframe
	CMP #60
     BNE .skipL0166
.condpart35
 jsr .stopvoiceone
	LDA #6
	STA gamestate
	DEC life
.skipL0166
.L0167 ;  return

	RTS
.
 ; 

.playerdying
 ; playerdying

.L0168 ;  player0y  =  player0y  +  1

	INC player0y
.L0169 ;  if player0y  =  74 then gamestate  =  8  :  gosub playdeathsound

	LDA player0y
	CMP #74
     BNE .skipL0169
.condpart36
	LDA #8
	STA gamestate
 jsr .playdeathsound

.skipL0169
.L0170 ;  return

	RTS
.
 ; 

.playerruntosafety
 ; playerruntosafety

.L0171 ;  player0x  =  player0x  +  1

	INC player0x
.
 ; 

.L0172 ;  rem REACHED SAFETY AT THE END OF SCREEN

.L0173 ;  if player0x  =  139 then gamestate  =  6  :  score  =  score  +  1  :  gosub stopvoiceone  :  life = life - 1

	LDA player0x
	CMP #139
     BNE .skipL0173
.condpart37
	LDA #6
	STA gamestate
	SED
	CLC
	LDA score+2
	ADC #$01
	STA score+2
	LDA score+1
	ADC #$00
	STA score+1
	LDA score
	ADC #$00
	STA score
	CLD
 jsr .stopvoiceone
	DEC life
.skipL0173
.L0174 ;  return

	RTS
.
 ; 

.playeronvine
 ; playeronvine

.L0175 ;  if frame  =  20 then player0x  =  98

	LDA frame
	CMP #20
     BNE .skipL0175
.condpart38
	LDA #98
	STA player0x
.skipL0175
.L0176 ;  if frame  =  30 then player0x  =  106

	LDA frame
	CMP #30
     BNE .skipL0176
.condpart39
	LDA #106
	STA player0x
.skipL0176
.L0177 ;  if frame  =  40 then player0x  =  111

	LDA frame
	CMP #40
     BNE .skipL0177
.condpart40
	LDA #111
	STA player0x
.skipL0177
.L0178 ;  if frame  =  50 then player0x  =  116

	LDA frame
	CMP #50
     BNE .skipL0178
.condpart41
	LDA #116
	STA player0x
.skipL0178
.L0179 ;  if frame  =  60 then player0x  =  121

	LDA frame
	CMP #60
     BNE .skipL0179
.condpart42
	LDA #121
	STA player0x
.skipL0179
.
 ; 

.L0180 ;  rem REACHED THE OTHER SIDE OF THE PIT

.L0181 ;  if frame  =  60 then gamestate  =  5  :  gosub playvictorysound

	LDA frame
	CMP #60
     BNE .skipL0181
.condpart43
	LDA #5
	STA gamestate
 jsr .playvictorysound

.skipL0181
.
 ; 

.L0182 ;  return

	RTS
.
 ; 

.playerrunning
 ; playerrunning

.L0183 ;  player0x  =  player0x  +  1

	INC player0x
.L0184 ;  rem CHECK WHETHER THE PLAYER CATCHES THE VINE WHEN HE REACHES END OF PIT

.L0185 ;  if player0x  =  90 then gosub didplayercatchvine

	LDA player0x
	CMP #90
     BNE .skipL0185
.condpart44
 jsr .didplayercatchvine

.skipL0185
.L0186 ;  return

	RTS
.
 ; 

.didplayercatchvine
 ; didplayercatchvine

.L0187 ;  rem DID PLAYER CATCH VINE? IF NOT, THEN ENTER DYING STATE, AND MOVE SNAPPY UNDERNEATH PLAYER

.L0188 ;  if frame  <=  10  ||  frame  >=  115 then gamestate  =  4 else gamestate  =  7  :  player1x  =  90

	LDA #10
	CMP frame
     BCC .skipL0188
.condpart45
 jmp .condpart46
.skipL0188
	LDA frame
	CMP #115
     BCC .skip6OR
.condpart46
	LDA #4
	STA gamestate
 jmp .skipelse1
.skip6OR
	LDA #7
	STA gamestate
	LDA #90
	STA player1x
.skipelse1
.L0189 ;  return

	RTS
.
 ; 

.playerwaiting
 ; playerwaiting

.L0190 ;  rem WE DON'T WANT THE PLAYER ANIMATING, SO WE'LL JUST KEEP HIS

.L0191 ;  rem ANIMATION FRAME AT 0

.L0192 ;  playerframe  =  0

	LDA #0
	STA playerframe
.
 ; 

.L0193 ;  rem IF FIRE IS PRESSED, PUT PLAYER IN RUNNING MODE

.L0194 ;  if joy0fire then gamestate  =  3

 lda #$80
 bit INPT4
	BNE .skipL0194
.condpart47
	LDA #3
	STA gamestate
.skipL0194
.L0195 ;  return

	RTS
.
 ; 

.dropplayer
 ; dropplayer

.L0196 ;  player0y  =  player0y  +  1

	INC player0y
.L0197 ;  rem DID PLAYER REACH GROUND?

.L0198 ;  if player0y  =  56 then gamestate  =  2

	LDA player0y
	CMP #56
     BNE .skipL0198
.condpart48
	LDA #2
	STA gamestate
.skipL0198
.
 ; 

.L0199 ;  rem WE DON'T WANT THE PLAYER ANIMATING, SO WE'LL JUST KEEP HIS

.L0200 ;  rem ANIMATION FRAME AT 0

.L0201 ;  playerframe  =  0

	LDA #0
	STA playerframe
.L0202 ;  return

	RTS
.
 ; 

.createplayer
 ; createplayer

.L0203 ;  rem SPAWN PLAYER

.L0204 ;  player0x  =  20  +   ( rand  /  4 ) 

; complex statement detected
	LDA #20
	PHA
 jsr randomize
	lsr
	lsr
	TSX
	INX
	TXS
	CLC
	ADC $100,x
	STA player0x
.L0205 ;  player0y  =  10

	LDA #10
	STA player0y
.L0206 ;  gamestate  =  1

	LDA #1
	STA gamestate
.L0207 ;  playerframe  =  0

	LDA #0
	STA playerframe
.
 ; 

.L0208 ;  rem RESET SNAPPY

.L0209 ;  player1x  =  102

	LDA #102
	STA player1x
.L0210 ;  player1y  =  80

	LDA #80
	STA player1y
.L0211 ;  snappyeatingframe  =  0

	LDA #0
	STA snappyeatingframe
.L0212 ;  return

	RTS
 if (<*) > (<(*+12))
	repeat ($100-<*)
	.byte 0
	repend
	endif
player2then_1

	.byte 0
	.byte    %00111100
	.byte    %00111100
	.byte    %00111100
	.byte    %00111100
	.byte    %01100111
	.byte    %01100110
	.byte    %01100110
	.byte    %11000011
	.byte    %11000011
	.byte    %11000011
	.byte    %10000001
 if (<*) > (<(*+12))
	repeat ($100-<*)
	.byte 0
	repend
	endif
player3then_1

	.byte 0
	.byte    %00111100
	.byte    %00111100
	.byte    %00111100
	.byte    %00111100
	.byte    %00111110
	.byte    %00111100
	.byte    %00111100
	.byte    %00111100
	.byte    %00011100
	.byte    %00011100
	.byte    %00011000
 if (<*) > (<(*+9))
	repeat ($100-<*)
	.byte 0
	repend
	endif
player16then_0

	.byte 0
	.byte         %00110110
	.byte         %00100100
	.byte         %00100100
	.byte         %00011000
	.byte         %01111110
	.byte         %00011000
	.byte         %00111100
	.byte         %00111100
 if (<*) > (<(*+9))
	repeat ($100-<*)
	.byte 0
	repend
	endif
player17then_0

	.byte 0
	.byte         %00011100
	.byte         %00011000
	.byte         %00011000
	.byte         %00011010
	.byte         %00111100
	.byte         %01011000
	.byte         %00111100
	.byte         %00111100
 if (<*) > (<(*+17))
	repeat ($100-<*)
	.byte 0
	repend
	endif
playerL0114_0

	.byte 0
	.byte         %00110110
	.byte         %00100100
	.byte         %00100100
	.byte         %00011000
	.byte         %00111100
	.byte         %01011010
	.byte         %01111110
	.byte         %01111110
	.byte 		%00100100
	.byte 		%00100100
	.byte 		%01000010
	.byte 		%10000001
	.byte 		%11111111
	.byte 		%11111111
	.byte 		%01111110
	.byte 		%00111100
 if (<*) > (<(*+9))
	repeat ($100-<*)
	.byte 0
	repend
	endif
playerL0116_0

	.byte 0
	.byte 		%00000000
	.byte         %00000000
	.byte         %00000000
	.byte         %00000000
	.byte         %00011110
	.byte         %00011000
	.byte         %00111100
	.byte         %00111100
       echo "    ",[(scoretable - *)]d , "bytes of ROM space left")
 
 
 
