   rem =====================================================================
   rem 
   rem    Snappy - an Atari 2600 game by Sebastian Mihai (2012)
   rem 
   rem    http://sebastianmihai.com (site was operational in 2012)
   rem
   rem    The code should be easy enough to follow, and I think it makes a
   rem    great starting point for developers wishing to program the Atari
   rem    2600. If you have any questions regarding why a certain thing is
   rem    done a certain way, please contact me through the method
   rem    mentioned on the home page of the website.
   rem 
   rem =====================================================================
   
   rem BATARI DEFINES VARIABLES WITH NAMES FROM A TO Z
   rem THE STATEMENTS BELOW SIMPLY RENAME THE VARIABLES WITH MORE MEANINGFUL NAMES
   dim frame = d
   dim playerframe = e
   dim gamestate = f
   dim snappyframe = g
   dim introcolour = h
   dim snappyeatingframe = i
   dim life = j
   dim randseed = k

   rem FRAME MOVES BETWEEN 0 AND 119
   rem VINE POSITION IS BASED ON IT
   frame = 30

   rem USED TO SEED RANDOM NUMBER SEQUENCE WHILE WAITING FOR PLAYER TO START GAME
   randseed = 0
   
   rem PLAYERFRAME CONTROLS PLAYER ANIMATION
   playerframe = 0
   
   rem ========= GAMESTATE VALUES ========
   rem 1 PLAYER DROPPING
   rem 2 PLAYER WAITING
   rem 3 PLAYER MOVING TOWARDS PIT
   rem 4 PLAYER HOLDING ON TO VINE
   rem 5 PLAYER MOVING TO GOAL
   rem 6 PLAYER SAFE
   rem 7 PLAYER DYING
   rem 8 SNAPPY EATING
   rem ====================================
   gamestate = 6

   rem SCORE IS DISPLAYED IN THIS COLOUR
   scorecolor = 22
   
   rem INITIAL TITLE SCREEN COLOUR
   introcolour = 0
   
   goto main
   
 rem =================================
 rem ====== SHOW INTRO AND WAIT ======
 rem =================================
showintro
  playfield:
   ................................
   ...XXX..........................
   ..X...X.........................
   ..X.............................
   ...XXX..XX...XXX..XX..XX..X..X..
   ......X.X.X.X..X..X.X.X.X.X..X..
   ..X...X.X.X.X..X..X.X.X.X.X..X..
   ...XXX..X.X..XX.X.XX..XX...XXX..
   ..................X...X......X..
   ..................X...X....XX...
   ................................
end
  
  introcolour = introcolour + 1
  COLUPF = introcolour
  COLUBK = 0
  COLUP0 = 0
  COLUP1 = 0
  player0x = 0
  player0y = 0
  player1x = 0
  player1y = 0
  randseed = randseed + 1
  gosub stopvoiceone
  gosub stopvoicezero
  drawscreen
  if joy0fire then goto initialize
  goto showintro

 rem =================================
 rem ====== INITIALIZE GAME ==========
 rem =================================
initialize
   score = 0
   life = 10
   if randseed = 0 then rand = 1 else rand = randseed
   goto main
   
   rem ===================================================
   rem =============== ANIMATE SNAPPY ====================
   rem ===================================================
animatesnappy
  if snappyframe = 0 then player1:
   %00111100
   %00111100
   %00111100
   %00111100
   %01100111
   %01100110
   %01100110
   %11000011
   %11000011
   %11000011
   %10000001
end
   if snappyframe = 10 then player1:
   %00111100
   %00111100
   %00111100
   %00111100
   %00111110
   %00111100
   %00111100
   %00111100
   %00011100
   %00011100
   %00011000
end
   return

   rem ===================================================
   rem =============== VINE ANIMATION ====================
   rem ===================================================
swingvine
   
   if frame = 0 then playfield:
   ..................XXXXXXXXX.....
   ......................X.........
   .....................X..........
   ....................X...........
   ...................X............
   ..................X.............
   ................................
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
end
   if frame = 10 || frame = 110 then playfield:
   ..................XXXXXXXXX.....
   ......................X.........
   .....................X..........
   .....................X..........
   ....................X...........
   ...................X...........
   ................................
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
end
   if frame = 20 || frame = 100 then playfield:
   ..................XXXXXXXXX.....
   ......................X.........
   ......................X.........
   .....................X..........
   .....................X..........
   .....................X..........
   ................................
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
end
   if frame = 30 || frame = 90 then playfield:
   ..................XXXXXXXXX.....
   ......................X.........
   ......................X.........
   ......................X.........
   ......................X.........
   ......................X.........
   ................................
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
end
   if frame = 40 || frame = 80 then playfield:
   ..................XXXXXXXXX.....
   ......................X.........
   ......................X.........
   .......................X........
   .......................X........
   .......................X........
   ................................
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
end
   if frame = 50 || frame = 70 then playfield:
   ..................XXXXXXXXX.....
   ......................X.........
   .......................X........
   .......................X........
   ........................X.......
   .........................X......
   ................................
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
end
   if frame = 60 then playfield:
   ..................XXXXXXXXX.....
   ......................X.........
   .......................X........
   ........................X.......
   .........................X......
   ..........................X.....
   ................................
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXX.........XXXXX
   XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
end
  if frame = 0 gosub playvinesound
  if frame = 60 gosub playvinesecondsound
  if frame = 3 gosub stopvoicezero
  if frame = 63 gosub stopvoicezero
  return  

  rem ===========================
  rem ==== SOUND ROUTINES =======
  rem ===========================
playvinesound
  AUDV0=4:AUDC0=12:AUDF0=28
  return
  
playvinesecondsound
  AUDV0=4:AUDC0=12:AUDF0=20
  return
  
playdeathsound
  AUDV1=4:AUDC1=14:AUDF1=20
  return

playvictorysound
  AUDV1=4:AUDC1=4:AUDF1=10
  return
  
stopvoicezero
  AUDV0=0
  return
  
stopvoiceone
  AUDV1=0
  return
  
  rem ===========================================
  rem =============== DRAW PLAYER ===============
  rem ===========================================
drawplayer
  if playerframe = 0 then player0:
        %00110110
        %00100100
        %00100100
        %00011000
        %01111110
        %00011000
        %00111100
        %00111100
end
  if playerframe = 10 then player0:
        %00011100
        %00011000
        %00011000
        %00011010
        %00111100
        %01011000
        %00111100
        %00111100
end
  return

drawplayerparachute
  player0:
        %00110110
        %00100100
        %00100100
        %00011000
        %00111100
        %01011010
        %01111110
        %01111110
		%00100100
		%00100100
		%01000010
		%10000001
		%11111111
		%11111111
		%01111110
		%00111100
end
  return
  
drawplayerbeingeaten
  player0:
		%00000000
        %00000000
        %00000000
        %00000000
        %00011110
        %00011000
        %00111100
        %00111100
end
  return
  
 rem =================================
 rem ====== MAIN GAME LOOP ===========
 rem =================================
main

  rem GAME OVER?
  if life = 0 then goto showintro

  rem SET VINE FRAME GRAPHICS
  gosub swingvine
  
  rem SET SNAPPY FRAME GRAPHICS
  gosub animatesnappy
  
  rem SET PLAYER FRAME GRAPHICS
  if gamestate = 1 then gosub drawplayerparachute
  if gamestate = 8 then gosub drawplayerbeingeaten
  if gamestate <> 1 && gamestate <> 8 then gosub drawplayer

  rem ADVANCE FRAMES
  frame=frame+1
  playerframe=playerframe+1
  snappyframe=snappyframe+1
  
  rem SNAPPY CHOMPS FASTER WHEN HE'S EATING THE PLAYER!!
  if gamestate = 8 then snappyframe=snappyframe+1
  
  rem APPLY BOUND TO FRAMES
  if playerframe >= 20 then playerframe=0
  if frame>=120 then frame=0
  if snappyframe >= 20 then snappyframe=0
  
  rem CALCULATE NEW PLAYER POSITION, ENFORCE GAME RULES, ETC.
  gosub handlestate
   
  COLUP1 = 206
  COLUP0 = 28
  COLUBK = 192
  COLUPF = 88
   
  rem PERFORM ACTUAL RENDERING
  drawscreen

  rem BACK TO BEGINNING OF GAME LOOP
  goto main

  rem =========================================
  rem = HANDLE GAME STATES BY MOVING PLAYER ===
  rem = CHECKING GAME RULES AND STATE CHANGES =
  rem =========================================
handlestate
  if gamestate = 6 then gosub createplayer : return
  if gamestate = 1 then gosub dropplayer : return
  if gamestate = 2 then gosub playerwaiting : return
  if gamestate = 3 then gosub playerrunning : return
  if gamestate = 4 then gosub playeronvine : return
  if gamestate = 7 then gosub playerdying : return
  if gamestate = 5 then gosub playerruntosafety : return
  if gamestate = 8 then gosub snappyeating : return
  return

snappyeating
   snappyeatingframe = snappyeatingframe + 1
   playerframe=0
   if snappyeatingframe = 60 then gosub stopvoiceone : gamestate = 6 : life=life-1
   return
  
playerdying
  player0y = player0y + 1
  if player0y = 74 then gamestate = 8 : gosub playdeathsound
  return
  
playerruntosafety
  player0x = player0x + 1
  
  rem REACHED SAFETY AT THE END OF SCREEN
  if player0x = 139 then gamestate = 6 : score = score + 1 : gosub stopvoiceone : life=life-1
  return
  
playeronvine  
  if frame = 20 then player0x = 98
  if frame = 30 then player0x = 106
  if frame = 40 then player0x = 111
  if frame = 50 then player0x = 116
  if frame = 60 then player0x = 121
  
  rem REACHED THE OTHER SIDE OF THE PIT
  if frame = 60 then gamestate = 5 : gosub playvictorysound
  
  return
  
playerrunning
  player0x = player0x + 1
  rem CHECK WHETHER THE PLAYER CATCHES THE VINE WHEN HE REACHES END OF PIT
  if player0x = 90 then gosub didplayercatchvine
  return

didplayercatchvine
  rem DID PLAYER CATCH VINE? IF NOT, THEN ENTER DYING STATE, AND MOVE SNAPPY UNDERNEATH PLAYER
  if frame <= 10 || frame >= 115 then gamestate = 4 else gamestate = 7 : player1x = 90
  return
  
playerwaiting
  rem WE DON'T WANT THE PLAYER ANIMATING, SO WE'LL JUST KEEP HIS
  rem ANIMATION FRAME AT 0
  playerframe = 0
  
  rem IF FIRE IS PRESSED, PUT PLAYER IN RUNNING MODE
  if joy0fire then gamestate = 3
  return
  
dropplayer
  player0y = player0y + 1
  rem DID PLAYER REACH GROUND?
  if player0y = 56 then gamestate = 2
  
  rem WE DON'T WANT THE PLAYER ANIMATING, SO WE'LL JUST KEEP HIS
  rem ANIMATION FRAME AT 0
  playerframe = 0
  return

createplayer
  rem SPAWN PLAYER
  player0x = 20 + (rand / 4)
  player0y = 10
  gamestate = 1
  playerframe = 0
  
  rem RESET SNAPPY
  player1x = 102
  player1y = 80
  snappyeatingframe = 0
  return
