 processor 6502
 include "vcs.h"
 include "macro.h"
 include "2600basic.h"
 include "2600basic_variable_redefs.h"
 ifconst bankswitch
  if bankswitch == 8
     ORG $1000
     RORG $D000
  endif
  if bankswitch == 16
     ORG $1000
     RORG $9000
  endif
  if bankswitch == 32
     ORG $1000
     RORG $1000
  endif
 else
   ORG $F000
 endif
; This is a 2-line kernel!
kernel
 sta WSYNC
 lda #255
 sta TIM64T

 lda #1
 sta VDELBL
 sta VDELP0
 ldx ballheight
 inx
 inx
 stx temp4
 lda player1y
 sta temp3

 ifconst shakescreen
   jsr doshakescreen
 else
   ldx missile0height
   inx
 endif

 inx
 stx stack1

 lda bally
 sta stack2

 lda player0y
 ldx #0
 sta WSYNC
 stx GRP0
 stx GRP1
 stx PF1
 stx PF2
 stx CXCLR
 ifconst readpaddle
   stx paddle
 else
   sleep 3
 endif

 sta temp2,x

 ;store these so they can be retrieved later
 ifnconst pfres
   ldx #128-44
 else
   ldx #132-pfres*4
 endif

 inc player1y

 lda missile0y
 sta temp5
 lda missile1y
 sta temp6

 lda playfieldpos
 sta temp1
 
 ifconst pfrowheight
 lda #pfrowheight+2
 else
 ifnconst pfres
   lda #10
 else
   lda #(96/pfres)+2 ; try to come close to the real size
 endif
 endif

 clc
 sbc playfieldpos
 sta playfieldpos
 jmp .startkernel

.skipDrawP0
 lda #0
 tay
 jmp .continueP0

.skipDrawP1
 lda #0
 tay
 jmp .continueP1

.kerloop ; enter at cycle 59??

continuekernel
 sleep 2
continuekernel2
 lda ballheight
 
 ifconst pfres
 ldy playfield+pfres*4-132,x
 sty PF1 ;3
 ldy playfield+pfres*4-131,x
 sty PF2 ;3
 ldy playfield+pfres*4-129,x
 sty PF1 ; 3 too early?
 ldy playfield+pfres*4-130,x
 sty PF2 ;3
 else
 ldy playfield+44-128,x ;4
 sty PF1 ;3
 ldy playfield+45-128,x ;4
 sty PF2 ;3
 ldy playfield+47-128,x ;4
 sty PF1 ; 3 too early?
 ldy playfield+46-128,x;4
 sty PF2 ;3
 endif

 dcp bally
 rol
 rol
; rol
; rol
goback
 sta ENABL 
.startkernel
 lda player1height ;3
 dcp player1y ;5
 bcc .skipDrawP1 ;2
 ldy player1y ;3
 lda (player1pointer),y ;5; player0pointer must be selected carefully by the compiler
			; so it doesn't cross a page boundary!

.continueP1
 sta GRP1 ;3

 ifnconst player1colors
   lda missile1height ;3
   dcp missile1y ;5
   rol;2
   rol;2
   sta ENAM1 ;3
 else
   lda (player1color),y
   sta COLUP1
 ifnconst playercolors
   sleep 7
 else
   lda.w player0colorstore
   sta COLUP0
 endif
 endif

 ifconst pfres
 lda playfield+pfres*4-132,x 
 sta PF1 ;3
 lda playfield+pfres*4-131,x 
 sta PF2 ;3
 lda playfield+pfres*4-129,x 
 sta PF1 ; 3 too early?
 lda playfield+pfres*4-130,x 
 sta PF2 ;3
 else
 lda playfield+44-128,x ;4
 sta PF1 ;3
 lda playfield+45-128,x ;4
 sta PF2 ;3
 lda playfield+47-128,x ;4
 sta PF1 ; 3 too early?
 lda playfield+46-128,x;4
 sta PF2 ;3
 endif 
; sleep 3

 lda player0height
 dcp player0y
 bcc .skipDrawP0
 ldy player0y
 lda (player0pointer),y
.continueP0
 sta GRP0

 ifnconst no_blank_lines
 ifnconst playercolors
   lda missile0height ;3
   dcp missile0y ;5
   sbc stack1
   sta ENAM0 ;3
 else
   lda (player0color),y
   sta player0colorstore
   sleep 6
 endif
   dec temp1
   bne continuekernel
 else
   dec temp1
   beq altkernel2
 ifconst readpaddle
   ldy currentpaddle
   lda INPT0,y
   bpl noreadpaddle
   inc paddle
   jmp continuekernel2
noreadpaddle
   sleep 2
   jmp continuekernel
 else
 ifnconst playercolors 
 ifconst PFcolors
   txa
   tay
   lda (pfcolortable),y
 ifnconst backgroundchange
   sta COLUPF
 else
   sta COLUBK
 endif
   jmp continuekernel
 else
   sleep 12
 endif
 else
   lda (player0color),y
   sta player0colorstore
   sleep 4
 endif
   jmp continuekernel
 endif
altkernel2
   txa
   sbx #252
   bmi lastkernelline
 ifconst pfrowheight
 lda #pfrowheight
 else
 ifnconst pfres
   lda #8
 else
   lda #(96/pfres) ; try to come close to the real size
 endif
 endif
   sta temp1
   jmp continuekernel
 endif

altkernel

 ifconst PFmaskvalue
   lda #PFmaskvalue
 else
   lda #0
 endif
 sta PF1
 sta PF2


 ;sleep 3

 ;28 cycles to fix things
 ;minus 11=17

; lax temp4
; clc
 txa
 sbx #252

 bmi lastkernelline

 ifconst PFcolorandheight
   ldy playfieldcolorandheight-87,x
 ifnconst backgroundchange
   sty COLUPF
 else
   sty COLUBK
 endif
   lda playfieldcolorandheight-88,x
   sta.w temp1
 endif
 ifconst PFheights
   lsr
   lsr
   tay
   lda (pfheighttable),y
   sta.w temp1
 endif
 ifconst PFcolors
   tay
   lda (pfcolortable),y
 ifnconst backgroundchange
   sta COLUPF
 else
   sta COLUBK
 endif
 ifconst pfrowheight
 lda #pfrowheight
 else
 ifnconst pfres
   lda #8
 else
   lda #(96/pfres) ; try to come close to the real size
 endif
 endif
   sta temp1
 endif
 ifnconst PFcolorandheight
 ifnconst PFcolors
 ifnconst PFheights
 ifnconst no_blank_lines
 ; read paddle 0
 ; lo-res paddle read
  ; bit INPT0
  ; bmi paddleskipread
  ; inc paddle0
;donepaddleskip
   sleep 10
 ifconst pfrowheight
   lda #pfrowheight
 else
 ifnconst pfres
   lda #8
 else
   lda #(96/pfres) ; try to come close to the real size
 endif
 endif
   sta temp1
 endif
 endif
 endif
 endif
 

 lda ballheight
 dcp bally
 sbc temp4


 jmp goback


 ifnconst no_blank_lines
lastkernelline
 ifnconst PFcolors
   sleep 10
 else
   ldy #124
   lda (pfcolortable),y
   sta COLUPF
 endif

 ifconst PFheights
 ldx #1
 sleep 4
 else
 ldx playfieldpos
 sleep 3
 endif

 jmp enterlastkernel

 else
lastkernelline
 
 ifconst PFheights
 ldx #1
 sleep 5
 else
   ldx playfieldpos
 sleep 4
 endif

   cpx #1
   bne .enterfromNBL
   jmp no_blank_lines_bailout
 endif

 if ((<*)>$d5)
 align 256
 endif
 ; this is a kludge to prevent page wrapping - fix!!!

.skipDrawlastP1
 sleep 2
 lda #0
 jmp .continuelastP1

.endkerloop ; enter at cycle 59??
 
 nop

.enterfromNBL
 ifconst pfres
 ldy.w playfield+pfres*4-4
 sty PF1 ;3
 ldy.w playfield+pfres*4-3
 sty PF2 ;3
 ldy.w playfield+pfres*4-1
 sty PF1 ; possibly too early?
 ldy.w playfield+pfres*4-2
 sty PF2 ;3
 else
 ldy.w playfield+44
 sty PF1 ;3
 ldy.w playfield+45
 sty PF2 ;3
 ldy.w playfield+47
 sty PF1 ; possibly too early?
 ldy.w playfield+46
 sty PF2 ;3
 endif

enterlastkernel
 lda ballheight

; tya
 dcp bally
; sleep 4

; sbc stack3
 rol
 rol
 sta ENABL 

 lda player1height ;3
 dcp player1y ;5
 bcc .skipDrawlastP1
 ldy player1y ;3
 lda (player1pointer),y ;5; player0pointer must be selected carefully by the compiler
			; so it doesn't cross a page boundary!

.continuelastP1
 sta GRP1 ;3

 ifnconst player1colors
   lda missile1height ;3
   dcp missile1y ;5
 else
   lda (player1color),y
   sta COLUP1
 endif

 dex
 ;dec temp4 ; might try putting this above PF writes
 beq endkernel


 ifconst pfres
 ldy.w playfield+pfres*4-4
 sty PF1 ;3
 ldy.w playfield+pfres*4-3
 sty PF2 ;3
 ldy.w playfield+pfres*4-1
 sty PF1 ; possibly too early?
 ldy.w playfield+pfres*4-2
 sty PF2 ;3
 else
 ldy.w playfield+44
 sty PF1 ;3
 ldy.w playfield+45
 sty PF2 ;3
 ldy.w playfield+47
 sty PF1 ; possibly too early?
 ldy.w playfield+46
 sty PF2 ;3
 endif

 ifnconst player1colors
   rol;2
   rol;2
   sta ENAM1 ;3
 else
 ifnconst playercolors
   sleep 7
 else
   lda.w player0colorstore
   sta COLUP0
 endif
 endif
 
 lda.w player0height
 dcp player0y
 bcc .skipDrawlastP0
 ldy player0y
 lda (player0pointer),y
.continuelastP0
 sta GRP0



 ifnconst no_blank_lines
   lda missile0height ;3
   dcp missile0y ;5
   sbc stack1
   sta ENAM0 ;3
   jmp .endkerloop
 else
 ifconst readpaddle
   ldy currentpaddle
   lda INPT0,y
   bpl noreadpaddle2
   inc paddle
   jmp .endkerloop
noreadpaddle2
   sleep 4
   jmp .endkerloop
 else ; no_blank_lines and no paddle reading
 sleep 14
 jmp .endkerloop
 endif
 endif


;  ifconst donepaddleskip
;paddleskipread
 ; this is kind of lame, since it requires 4 cycles from a page boundary crossing
 ; plus we get a lo-res paddle read
; bmi donepaddleskip
;  endif

.skipDrawlastP0
 sleep 2
 lda #0
 jmp .continuelastP0

 ifconst no_blank_lines
no_blank_lines_bailout
 ldx #0
 endif

endkernel
 ; 6 digit score routine
 stx PF1
 stx PF2
 stx PF0
 clc

 ifconst pfrowheight
 lda #pfrowheight+2
 else
 ifnconst pfres
   lda #10
 else
   lda #(96/pfres)+2 ; try to come close to the real size
 endif
 endif

 sbc playfieldpos
 sta playfieldpos
 txa

 ifconst shakescreen
   bit shakescreen
   bmi noshakescreen2
   ldx #$3D
noshakescreen2
 endif

   sta WSYNC,x

;                STA WSYNC ;first one, need one more
 sta REFP0
 sta REFP1
                STA GRP0
                STA GRP1
 ;               STA PF1
   ;             STA PF2
 sta HMCLR
 sta ENAM0
 sta ENAM1
 sta ENABL

 lda temp2 ;restore variables that were obliterated by kernel
 sta player0y
 lda temp3
 sta player1y
 ifnconst player1colors
   lda temp6
   sta missile1y
 endif
 ifnconst playercolors
 ifnconst readpaddle
   lda temp5
   sta missile0y
 endif
 endif
 lda stack2
 sta bally

 ifconst no_blank_lines
 sta WSYNC
 endif

 lda INTIM
 clc
 ifnconst vblank_time
 adc #43+12+87
 else
 adc #vblank_time+12+87
 endif
; sta WSYNC
 sta TIM64T

 ifconst minikernel
 jsr minikernel
 endif

 ; now reassign temp vars for score pointers

; score pointers contain:
; score1-5: lo1,lo2,lo3,lo4,lo5,lo6
; swap lo2->temp1
; swap lo4->temp3
; swap lo6->temp5
 ifnconst noscore
 lda scorepointers+1
; ldy temp1
 sta temp1
; sty scorepointers+1

 lda scorepointers+3
; ldy temp3
 sta temp3
; sty scorepointers+3


 sta HMCLR
 tsx
 stx stack1 
 ldx #$10
 stx HMP0

 sta WSYNC
 ldx #0
                STx GRP0
                STx GRP1 ; seems to be needed because of vdel

 lda scorepointers+5
; ldy temp5
 sta temp5,x
; sty scorepointers+5
 lda #>scoretable
 sta scorepointers+1
 sta scorepointers+3
 sta scorepointers+5,x
 sta temp2,x
 sta temp4,x
 sta temp6,x
                LDY #7
                STA RESP0
                STA RESP1


        LDA #$03
        STA NUSIZ0
        STA NUSIZ1,x
        STA VDELP0
        STA VDELP1
        LDA #$20
        STA HMP1
               LDA scorecolor 
;               STA HMCLR
;               STA WSYNC; second one
                STA HMOVE ; cycle 73 ?

                STA COLUP0
                STA COLUP1
 lda  (scorepointers),y
 sta  GRP0
 ifconst pfscore
 lda pfscorecolor
 sta COLUPF
 endif
 lda  (scorepointers+8),y
 sta WSYNC
 sleep 2
 jmp beginscore

 if ((<*)>$d4)
 align 256 ; kludge that potentially wastes space!  should be fixed!
 endif

loop2
 lda  (scorepointers),y     ;+5  68  204
 sta  GRP0            ;+3  71  213      D1     --      --     --
 ifconst pfscore
 lda.w pfscore1
 sta PF1
 else
 sleep 7
 endif
 ; cycle 0
 lda  (scorepointers+$8),y  ;+5   5   15
beginscore
 sta  GRP1            ;+3   8   24      D1     D1      D2     --
 lda  (scorepointers+$6),y  ;+5  13   39
 sta  GRP0            ;+3  16   48      D3     D1      D2     D2
 lax  (scorepointers+$2),y  ;+5  29   87
 txs
 lax  (scorepointers+$4),y  ;+5  36  108
 sleep 3

 ifconst pfscore
 lda pfscore2
 sta PF1
 else
 sleep 6
 endif

 lda  (scorepointers+$A),y  ;+5  21   63
 stx  GRP1            ;+3  44  132      D3     D3      D4     D2!
 tsx
 stx  GRP0            ;+3  47  141      D5     D3!     D4     D4
 sta  GRP1            ;+3  50  150      D5     D5      D6     D4!
 sty  GRP0            ;+3  53  159      D4*    D5!     D6     D6
 dey
 bpl  loop2           ;+2  60  180

 ldx stack1 
 txs
; lda scorepointers+1
 ldy temp1
; sta temp1
 sty scorepointers+1

                LDA #0   
 sta PF1
               STA GRP0
                STA GRP1
        STA VDELP0
        STA VDELP1;do we need these
        STA NUSIZ0
        STA NUSIZ1

; lda scorepointers+3
 ldy temp3
; sta temp3
 sty scorepointers+3

; lda scorepointers+5
 ldy temp5
; sta temp5
 sty scorepointers+5
 endif ;noscore
 LDA #%11000010
 sta WSYNC
 STA VBLANK
 RETURN

 ifconst shakescreen
doshakescreen
   bit shakescreen
   bmi noshakescreen
   sta WSYNC
noshakescreen
   ldx missile0height
   inx
   rts
 endif

start
 sei
 cld
 ldy #0
 lda $D0
 cmp #$2C               ;check RAM location #1
 bne MachineIs2600
 lda $D1
 cmp #$A9               ;check RAM location #2
 bne MachineIs2600
 dey
MachineIs2600
 ldx #0
 txa
clearmem
 inx
 txs
 pha
 bne clearmem
 sty temp1
 ifconst pfrowheight
 lda pfrowheight
 else
 ifconst pfres
 lda #(96/pfres)
 else
 lda #8
 endif
 endif
 sta playfieldpos
 ldx #5
initscore
 lda #<scoretable
 sta scorepointers,x 
 dex
 bpl initscore
 lda #1
 sta CTRLPF
 ora INTIM
 sta rand

 ifconst multisprite
   jsr multisprite_setup
 endif

 ifnconst bankswitch
   jmp game
 else
   lda #>(game-1)
   pha
   lda #<(game-1)
   pha
   pha
   pha
   ldx #1
   jmp BS_jsr
 endif
; playfield drawing routines
; you get a 32x12 bitmapped display in a single color :)
; 0-31 and 0-11

pfclear ; clears playfield - or fill with pattern
 ifconst pfres
 ldx #pfres*4-1
 else
 ldx #47
 endif
pfclear_loop
 ifnconst superchip
 sta playfield,x
 else
 sta playfield-128,x
 endif
 dex
 bpl pfclear_loop
 RETURN
 
setuppointers
 stx temp2 ; store on.off.flip value
 tax ; put x-value in x 
 lsr
 lsr
 lsr ; divide x pos by 8 
 sta temp1
 tya
 asl
 asl ; multiply y pos by 4
 clc
 adc temp1 ; add them together to get actual memory location offset
 tay ; put the value in y
 lda temp2 ; restore on.off.flip value
 rts

pfread
;x=xvalue, y=yvalue
 jsr setuppointers
 lda setbyte,x
 and playfield,y
 eor setbyte,x
; beq readzero
; lda #1
; readzero
 RETURN

pfpixel
;x=xvalue, y=yvalue, a=0,1,2
 jsr setuppointers

 ifconst bankswitch
 lda temp2 ; load on.off.flip value (0,1, or 2)
 beq pixelon_r  ; if "on" go to on
 lsr
 bcs pixeloff_r ; value is 1 if true
 lda playfield,y ; if here, it's "flip"
 eor setbyte,x
 ifconst superchip
 sta playfield-128,y
 else
 sta playfield,y
 endif
 RETURN
pixelon_r
 lda playfield,y
 ora setbyte,x
 ifconst superchip
 sta playfield-128,y
 else
 sta playfield,y
 endif
 RETURN
pixeloff_r
 lda setbyte,x
 eor #$ff
 and playfield,y
 ifconst superchip
 sta playfield-128,y
 else
 sta playfield,y
 endif
 RETURN

 else
 jmp plotpoint
 endif

pfhline
;x=xvalue, y=yvalue, a=0,1,2, temp3=endx
 jsr setuppointers
 jmp noinc
keepgoing
 inx
 txa
 and #7
 bne noinc
 iny
noinc
 jsr plotpoint
 cpx temp3
 bmi keepgoing
 RETURN

pfvline
;x=xvalue, y=yvalue, a=0,1,2, temp3=endx
 jsr setuppointers
 sty temp1 ; store memory location offset
 inc temp3 ; increase final x by 1 
 lda temp3
 asl
 asl ; multiply by 4
 sta temp3 ; store it
 ; Thanks to Michael Rideout for fixing a bug in this code
 ; right now, temp1=y=starting memory location, temp3=final
 ; x should equal original x value
keepgoingy
 jsr plotpoint
 iny
 iny
 iny
 iny
 cpy temp3
 bmi keepgoingy
 RETURN

plotpoint
 lda temp2 ; load on.off.flip value (0,1, or 2)
 beq pixelon  ; if "on" go to on
 lsr
 bcs pixeloff ; value is 1 if true
 lda playfield,y ; if here, it's "flip"
 eor setbyte,x
  ifconst superchip
 sta playfield-128,y
 else
 sta playfield,y
 endif
 rts
pixelon
 lda playfield,y
 ora setbyte,x
 ifconst superchip
 sta playfield-128,y
 else
 sta playfield,y
 endif
 rts
pixeloff
 lda setbyte,x
 eor #$ff
 and playfield,y
 ifconst superchip
 sta playfield-128,y
 else
 sta playfield,y
 endif
 rts

setbyte
 .byte $80
 .byte $40
 .byte $20
 .byte $10
 .byte $08
 .byte $04
 .byte $02
 .byte $01
 .byte $01
 .byte $02
 .byte $04
 .byte $08
 .byte $10
 .byte $20
 .byte $40
 .byte $80
 .byte $80
 .byte $40
 .byte $20
 .byte $10
 .byte $08
 .byte $04
 .byte $02
 .byte $01
 .byte $01
 .byte $02
 .byte $04
 .byte $08
 .byte $10
 .byte $20
 .byte $40
 .byte $80
pfscroll ;(a=0 left, 1 right, 2 up, 4 down, 6=upup, 12=downdown)
 bne notleft
;left
 ifconst pfres
 ldx #pfres*4
 else
 ldx #48
 endif
leftloop
 lda playfield-1,x
 lsr

 ifconst superchip
 lda playfield-2,x
 rol
 sta playfield-130,x
 lda playfield-3,x
 ror
 sta playfield-131,x
 lda playfield-4,x
 rol
 sta playfield-132,x
 lda playfield-1,x
 ror
 sta playfield-129,x
 else
 rol playfield-2,x
 ror playfield-3,x
 rol playfield-4,x
 ror playfield-1,x
 endif

 txa
 sbx #4
 bne leftloop
 RETURN

notleft
 lsr
 bcc notright
;right

 ifconst pfres
 ldx #pfres*4
 else
 ldx #48
 endif
rightloop
 lda playfield-4,x
 lsr
 ifconst superchip
 lda playfield-3,x
 rol
 sta playfield-131,x
 lda playfield-2,x
 ror
 sta playfield-130,x
 lda playfield-1,x
 rol
 sta playfield-129,x
 lda playfield-4,x
 ror
 sta playfield-132,x
 else
 rol playfield-3,x
 ror playfield-2,x
 rol playfield-1,x
 ror playfield-4,x
 endif
 txa
 sbx #4
 bne rightloop
  RETURN

notright
 lsr
 bcc notup
;up
 lsr
 bcc onedecup
 dec playfieldpos
onedecup
 dec playfieldpos
 beq shiftdown 
 bpl noshiftdown2 
shiftdown
  ifconst pfrowheight
 lda #pfrowheight
 else
 ifnconst pfres
   lda #8
 else
   lda #(96/pfres) ; try to come close to the real size
 endif
 endif

 sta playfieldpos
 lda playfield+3
 sta temp4
 lda playfield+2
 sta temp3
 lda playfield+1
 sta temp2
 lda playfield
 sta temp1
 ldx #0
up2
 lda playfield+4,x
 ifconst superchip
 sta playfield-128,x
 lda playfield+5,x
 sta playfield-127,x
 lda playfield+6,x
 sta playfield-126,x
 lda playfield+7,x
 sta playfield-125,x
 else
 sta playfield,x
 lda playfield+5,x
 sta playfield+1,x
 lda playfield+6,x
 sta playfield+2,x
 lda playfield+7,x
 sta playfield+3,x
 endif
 txa
 sbx #252
 ifconst pfres
 cpx #(pfres-1)*4
 else
 cpx #44
 endif
 bne up2

 lda temp4
 
 ifconst superchip
 ifconst pfres
 sta playfield+pfres*4-129
 lda temp3
 sta playfield+pfres*4-130
 lda temp2
 sta playfield+pfres*4-131
 lda temp1
 sta playfield+pfres*4-132
 else
 sta playfield+47-128
 lda temp3
 sta playfield+46-128
 lda temp2
 sta playfield+45-128
 lda temp1
 sta playfield+44-128
 endif
 else
 ifconst pfres
 sta playfield+pfres*4-1
 lda temp3
 sta playfield+pfres*4-2
 lda temp2
 sta playfield+pfres*4-3
 lda temp1
 sta playfield+pfres*4-4
 else
 sta playfield+47
 lda temp3
 sta playfield+46
 lda temp2
 sta playfield+45
 lda temp1
 sta playfield+44
 endif
 endif
noshiftdown2
 RETURN


notup
;down
 lsr
 bcs oneincup
 inc playfieldpos
oneincup
 inc playfieldpos
 lda playfieldpos

  ifconst pfrowheight
 cmp #pfrowheight+1
 else
 ifnconst pfres
   cmp #9
 else
   cmp #(96/pfres)+1 ; try to come close to the real size
 endif
 endif

 bcc noshiftdown 
 lda #1
 sta playfieldpos

 ifconst pfres
 lda playfield+pfres*4-1
 sta temp4
 lda playfield+pfres*4-2
 sta temp3
 lda playfield+pfres*4-3
 sta temp2
 lda playfield+pfres*4-4
 else
 lda playfield+47
 sta temp4
 lda playfield+46
 sta temp3
 lda playfield+45
 sta temp2
 lda playfield+44
 endif

 sta temp1

 ifconst pfres
 ldx #(pfres-1)*4
 else
 ldx #44
 endif
down2
 lda playfield-1,x
 ifconst superchip
 sta playfield-125,x
 lda playfield-2,x
 sta playfield-126,x
 lda playfield-3,x
 sta playfield-127,x
 lda playfield-4,x
 sta playfield-128,x
 else
 sta playfield+3,x
 lda playfield-2,x
 sta playfield+2,x
 lda playfield-3,x
 sta playfield+1,x
 lda playfield-4,x
 sta playfield,x
 endif
 txa
 sbx #4
 bne down2

 lda temp4
 ifconst superchip
 sta playfield-125
 lda temp3
 sta playfield-126
 lda temp2
 sta playfield-127
 lda temp1
 sta playfield-128
 else
 sta playfield+3
 lda temp3
 sta playfield+2
 lda temp2
 sta playfield+1
 lda temp1
 sta playfield
 endif
noshiftdown
 RETURN
;standard routines needed for pretty much all games
; just the random number generator is left - maybe we should remove this asm file altogether?
; repositioning code and score pointer setup moved to overscan
; read switches, joysticks now compiler generated (more efficient)

randomize
	lda rand
	lsr
 ifconst rand16
	rol rand16
 endif
	bcc noeor
	eor #$B4
noeor
	sta rand
 ifconst rand16
	eor rand16
 endif
	RETURN
drawscreen
 ifconst debugscore
   ldx #14
   lda INTIM ; display # cycles left in the score

 ifconst mincycles
 lda mincycles 
 cmp INTIM
 lda mincycles
 bcc nochange
 lda INTIM
 sta mincycles
nochange
 endif

;   cmp #$2B
;   bcs no_cycles_left
   bmi cycles_left
   ldx #64
   eor #$ff ;make negative
cycles_left
   stx scorecolor
   and #$7f ; clear sign bit
   tax
   lda scorebcd,x
   sta score+2
   lda scorebcd1,x
   sta score+1
   jmp done_debugscore   
scorebcd
 .byte $00, $64, $28, $92, $56, $20, $84, $48, $12, $76, $40
 .byte $04, $68, $32, $96, $60, $24, $88, $52, $16, $80, $44
 .byte $08, $72, $36, $00, $64, $28, $92, $56, $20, $84, $48
 .byte $12, $76, $40, $04, $68, $32, $96, $60, $24, $88
scorebcd1
 .byte 0, 0, 1, 1, 2, 3, 3, 4, 5, 5, 6
 .byte 7, 7, 8, 8, 9, $10, $10, $11, $12, $12, $13
 .byte $14, $14, $15, $16, $16, $17, $17, $18, $19, $19, $20
 .byte $21, $21, $22, $23, $23, $24, $24, $25, $26, $26
done_debugscore
 endif

 ifconst debugcycles
   lda INTIM ; if we go over, it mucks up the background color
;   cmp #$2B
;   BCC overscan
   bmi overscan
   sta COLUBK
   bcs doneoverscan
 endif

 
overscan
 lda INTIM ;wait for sync
 bmi overscan
doneoverscan
;do VSYNC
 lda #2
 sta WSYNC
 sta VSYNC
 STA WSYNC
 STA WSYNC
 LDA #0
 STA WSYNC
 STA VSYNC
 sta VBLANK
 ifnconst overscan_time
 lda #37+128
 else
 lda #overscan_time+128
 endif
 sta TIM64T

 ifconst legacy
 if legacy < 100
 ldx #4
adjustloop
 lda player0x,x
 sec
 sbc #14 ;?
 sta player0x,x
 dex
 bpl adjustloop
 endif
 endif
 if (<*)>$F0
 align 256, $EA
 endif
  sta WSYNC
  ldx #4
  SLEEP 3
HorPosLoop       ;     5
  lda player0x,X  ;+4   9
  sec           ;+2  11
DivideLoop
  sbc #15
  bcs DivideLoop;+4  15
  sta temp1,X    ;+4  19
  sta RESP0,X   ;+4  23
  sta WSYNC
  dex
  bpl HorPosLoop;+5   5
                ;     4

  ldx #4
  ldy temp1,X
  lda repostable-256,Y
  sta HMP0,X    ;+14 18

  dex
  ldy temp1,X
  lda repostable-256,Y
  sta HMP0,X    ;+14 32

  dex
  ldy temp1,X
  lda repostable-256,Y
  sta HMP0,X    ;+14 46

  dex
  ldy temp1,X
  lda repostable-256,Y
  sta HMP0,X    ;+14 60

  dex
  ldy temp1,X
  lda repostable-256,Y
  sta HMP0,X    ;+14 74

  sta WSYNC
 
  sta HMOVE     ;+3   3


 ifconst legacy
 if legacy < 100
 ldx #4
adjustloop2
 lda player0x,x
 clc
 adc #14 ;?
 sta player0x,x
 dex
 bpl adjustloop2
 endif
 endif




;set score pointers
 lax score+2
 jsr scorepointerset
 sty scorepointers+5
 stx scorepointers+2
 lax score+1
 jsr scorepointerset
 sty scorepointers+4
 stx scorepointers+1
 lax score
 jsr scorepointerset
 sty scorepointers+3
 stx scorepointers

vblk
; run possible vblank bB code
 ifconst vblank_bB_code
   jsr vblank_bB_code
 endif
vblk2
 LDA INTIM
 bmi vblk2
 jmp kernel
 

    .byte $80,$70,$60,$50,$40,$30,$20,$10,$00
    .byte $F0,$E0,$D0,$C0,$B0,$A0,$90
repostable

scorepointerset
 and #$0F
 asl
 asl
 asl
 adc #<scoretable
 tay 
 txa
; and #$F0
; lsr
 asr #$F0
 adc #<scoretable
 tax
 rts
game
.L00 ;  rem =====================================================================

.L01 ;  rem 

.L02 ;  rem    Snappy - an Atari 2600 game by Sebastian Mihai (2012)

.L03 ;  rem 

.L04 ;  rem    http://sebastianmihai.com (site was operational in 2012)

.L05 ;  rem

.L06 ;  rem    The code should be easy enough to follow, and I think it makes a

.L07 ;  rem    great starting point for developers wishing to program the Atari

.L08 ;  rem    2600. If you have any questions regarding why a certain thing is

.L09 ;  rem    done a certain way, please contact me through the method

.L010 ;  rem    mentioned on the home page of the website.

.L011 ;  rem 

.L012 ;  rem =====================================================================

.
 ; 

.L013 ;  rem BATARI DEFINES VARIABLES WITH NAMES FROM A TO Z

.L014 ;  rem THE STATEMENTS BELOW SIMPLY RENAME THE VARIABLES WITH MORE MEANINGFUL NAMES

.L015 ;  dim frame  =  d

.L016 ;  dim playerframe  =  e

.L017 ;  dim gamestate  =  f

.L018 ;  dim snappyframe  =  g

.L019 ;  dim introcolour  =  h

.L020 ;  dim snappyeatingframe  =  i

.L021 ;  dim life  =  j

.L022 ;  dim randseed  =  k

.
 ; 

.L023 ;  rem FRAME MOVES BETWEEN 0 AND 119

.L024 ;  rem VINE POSITION IS BASED ON IT

.L025 ;  frame  =  30

	LDA #30
	STA frame
.
 ; 

.L026 ;  rem USED TO SEED RANDOM NUMBER SEQUENCE WHILE WAITING FOR PLAYER TO START GAME

.L027 ;  randseed  =  0

	LDA #0
	STA randseed
.
 ; 

.L028 ;  rem PLAYERFRAME CONTROLS PLAYER ANIMATION

.L029 ;  playerframe  =  0

	LDA #0
	STA playerframe
.
 ; 

.L030 ;  rem ========= GAMESTATE VALUES ========

.L031 ;  rem 1 PLAYER DROPPING

.L032 ;  rem 2 PLAYER WAITING

.L033 ;  rem 3 PLAYER MOVING TOWARDS PIT

.L034 ;  rem 4 PLAYER HOLDING ON TO VINE

.L035 ;  rem 5 PLAYER MOVING TO GOAL

.L036 ;  rem 6 PLAYER SAFE

.L037 ;  rem 7 PLAYER DYING

.L038 ;  rem 8 SNAPPY EATING

.L039 ;  rem ====================================

.L040 ;  gamestate  =  6

	LDA #6
	STA gamestate
.
 ; 

.L041 ;  rem SCORE IS DISPLAYED IN THIS COLOUR

.L042 ;  scorecolor  =  22

	LDA #22
	STA scorecolor
.
 ; 

.L043 ;  rem INITIAL TITLE SCREEN COLOUR

.L044 ;  introcolour  =  0

	LDA #0
	STA introcolour
.
 ; 

.L045 ;  goto main

 jmp .main

.
 ; 

.L046 ;  rem =================================

.L047 ;  rem ====== SHOW INTRO AND WAIT ======

.L048 ;  rem =================================

.showintro
 ; showintro

.L049 ;  playfield:

  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel0
PF_data0
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %00011100, %00000000, %00000000, %00000000
	.byte %00100010, %00000000, %00000000, %00000000
	.byte %00100000, %00000000, %00000000, %00000000
	.byte %00011100, %11100011, %00110011, %00100100
	.byte %00000010, %10010101, %00101010, %00100101
	.byte %00100010, %10010101, %00101010, %00100101
	.byte %00011100, %01100101, %10110011, %00111000
	.byte %00000000, %00000000, %00100010, %00100000
	.byte %00000000, %00000000, %00100010, %00011000
	.byte %00000000, %00000000, %00000000, %00000000
pflabel0
	lda PF_data0,x
	sta playfield,x
	dex
	bpl pflabel0
.
 ; 

.L050 ;  introcolour  =  introcolour  +  1

	INC introcolour
.L051 ;  COLUPF  =  introcolour

	LDA introcolour
	STA COLUPF
.L052 ;  COLUBK  =  0

	LDA #0
	STA COLUBK
.L053 ;  COLUP0  =  0

	LDA #0
	STA COLUP0
.L054 ;  COLUP1  =  0

	LDA #0
	STA COLUP1
.L055 ;  player0x  =  0

	LDA #0
	STA player0x
.L056 ;  player0y  =  0

	LDA #0
	STA player0y
.L057 ;  player1x  =  0

	LDA #0
	STA player1x
.L058 ;  player1y  =  0

	LDA #0
	STA player1y
.L059 ;  randseed  =  randseed  +  1

 jsr randomize
	CLC
	ADC #1
	STA randseed
.L060 ;  gosub stopvoiceone

 jsr .stopvoiceone

.L061 ;  gosub stopvoicezero

 jsr .stopvoicezero

.L062 ;  drawscreen

 jsr drawscreen
.L063 ;  if joy0fire then goto initialize

 lda #$80
 bit INPT4
	BNE .skipL063
.condpart0
 jmp .initialize

.skipL063
.L064 ;  goto showintro

 jmp .showintro

.
 ; 

.L065 ;  rem =================================

.L066 ;  rem ====== INITIALIZE GAME ==========

.L067 ;  rem =================================

.initialize
 ; initialize

.L068 ;  score  =  0

	LDA #$00
	STA score+2
	LDA #$00
	STA score+1
	LDA #$00
	STA score
.L069 ;  life  =  10

	LDA #10
	STA life
.L070 ;  if randseed  =  0 then rand  =  1 else rand  =  randseed

	LDA randseed
	CMP #0
     BNE .skipL070
.condpart1
	LDA #1
	STA rand
 jmp .skipelse0
.skipL070
 jsr randomize
	STA rand
.skipelse0
.L071 ;  goto main

 jmp .main

.
 ; 

.L072 ;  rem ===================================================

.L073 ;  rem =============== ANIMATE SNAPPY ====================

.L074 ;  rem ===================================================

.animatesnappy
 ; animatesnappy

.L075 ;  if snappyframe  =  0 then player1:

	LDA snappyframe
	CMP #0
     BNE .skipL075
.condpart2
	LDA #<player2then_1

	STA player1pointerlo
	LDA #>player2then_1

	STA player1pointerhi
	LDA #11
	STA player1height
.skipL075
.L076 ;  if snappyframe  =  10 then player1:

	LDA snappyframe
	CMP #10
     BNE .skipL076
.condpart3
	LDA #<player3then_1

	STA player1pointerlo
	LDA #>player3then_1

	STA player1pointerhi
	LDA #11
	STA player1height
.skipL076
.L077 ;  return

	RTS
.
 ; 

.L078 ;  rem ===================================================

.L079 ;  rem =============== VINE ANIMATION ====================

.L080 ;  rem ===================================================

.swingvine
 ; swingvine

.
 ; 

.L081 ;  if frame  =  0 then playfield:

	LDA frame
	CMP #0
     BNE .skipL081
.condpart4
  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel1
PF_data1
	.byte %00000000, %00000000, %00111111, %00000111
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000100, %00000000
	.byte %00000000, %00000000, %00001000, %00000000
	.byte %00000000, %00000000, %00010000, %00000000
	.byte %00000000, %00000000, %00100000, %00000000
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11111111, %11111111
pflabel1
	lda PF_data1,x
	sta playfield,x
	dex
	bpl pflabel1
.skipL081
.L082 ;  if frame  =  10  ||  frame  =  110 then playfield:

	LDA frame
	CMP #10
     BNE .skipL082
.condpart5
 jmp .condpart6
.skipL082
	LDA frame
	CMP #110
     BNE .skip0OR
.condpart6
  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel2
PF_data2
	.byte %00000000, %00000000, %00111111, %00000111
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000100, %00000000
	.byte %00000000, %00000000, %00000100, %00000000
	.byte %00000000, %00000000, %00001000, %00000000
	.byte %00000000, %00000000, %00010000, %00000000
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11111111, %11111111
pflabel2
	lda PF_data2,x
	sta playfield,x
	dex
	bpl pflabel2
.skip0OR
.L083 ;  if frame  =  20  ||  frame  =  100 then playfield:

	LDA frame
	CMP #20
     BNE .skipL083
.condpart7
 jmp .condpart8
.skipL083
	LDA frame
	CMP #100
     BNE .skip1OR
.condpart8
  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel3
PF_data3
	.byte %00000000, %00000000, %00111111, %00000111
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000100, %00000000
	.byte %00000000, %00000000, %00000100, %00000000
	.byte %00000000, %00000000, %00000100, %00000000
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11111111, %11111111
pflabel3
	lda PF_data3,x
	sta playfield,x
	dex
	bpl pflabel3
.skip1OR
.L084 ;  if frame  =  30  ||  frame  =  90 then playfield:

	LDA frame
	CMP #30
     BNE .skipL084
.condpart9
 jmp .condpart10
.skipL084
	LDA frame
	CMP #90
     BNE .skip2OR
.condpart10
  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel4
PF_data4
	.byte %00000000, %00000000, %00111111, %00000111
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11111111, %11111111
pflabel4
	lda PF_data4,x
	sta playfield,x
	dex
	bpl pflabel4
.skip2OR
.L085 ;  if frame  =  40  ||  frame  =  80 then playfield:

	LDA frame
	CMP #40
     BNE .skipL085
.condpart11
 jmp .condpart12
.skipL085
	LDA frame
	CMP #80
     BNE .skip3OR
.condpart12
  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel5
PF_data5
	.byte %00000000, %00000000, %00111111, %00000111
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000001, %00000000
	.byte %00000000, %00000000, %00000001, %00000000
	.byte %00000000, %00000000, %00000001, %00000000
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11111111, %11111111
pflabel5
	lda PF_data5,x
	sta playfield,x
	dex
	bpl pflabel5
.skip3OR
.L086 ;  if frame  =  50  ||  frame  =  70 then playfield:

	LDA frame
	CMP #50
     BNE .skipL086
.condpart13
 jmp .condpart14
.skipL086
	LDA frame
	CMP #70
     BNE .skip4OR
.condpart14
  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel6
PF_data6
	.byte %00000000, %00000000, %00111111, %00000111
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000001, %00000000
	.byte %00000000, %00000000, %00000001, %00000000
	.byte %00000000, %00000000, %00000000, %00000001
	.byte %00000000, %00000000, %00000000, %00000010
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11111111, %11111111
pflabel6
	lda PF_data6,x
	sta playfield,x
	dex
	bpl pflabel6
.skip4OR
.L087 ;  if frame  =  60 then playfield:

	LDA frame
	CMP #60
     BNE .skipL087
.condpart15
  ifconst pfres
    ldx #4*pfres-1
  else
	  ldx #47
  endif
	jmp pflabel7
PF_data7
	.byte %00000000, %00000000, %00111111, %00000111
	.byte %00000000, %00000000, %00000010, %00000000
	.byte %00000000, %00000000, %00000001, %00000000
	.byte %00000000, %00000000, %00000000, %00000001
	.byte %00000000, %00000000, %00000000, %00000010
	.byte %00000000, %00000000, %00000000, %00000100
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11000000, %11111000
	.byte %11111111, %11111111, %11111111, %11111111
pflabel7
	lda PF_data7,x
	sta playfield,x
	dex
	bpl pflabel7
.skipL087
.L088 ;  if frame  =  0 gosub playvinesound

	LDA frame
	CMP #0
	beq .playvinesound
.L089 ;  if frame  =  60 gosub playvinesecondsound

	LDA frame
	CMP #60
	beq .playvinesecondsound
.L090 ;  if frame  =  3 gosub stopvoicezero

	LDA frame
	CMP #3
	beq .stopvoicezero
.L091 ;  if frame  =  63 gosub stopvoicezero

	LDA frame
	CMP #63
	beq .stopvoicezero
.L092 ;  return

	RTS
.
 ; 

.L093 ;  rem ===========================

.L094 ;  rem ==== SOUND ROUTINES =======

.L095 ;  rem ===========================

.playvinesound
 ; playvinesound

.L096 ;  AUDV0 = 4 : AUDC0 = 12 : AUDF0 = 28

	LDA #4
	STA AUDV0
	LDA #12
	STA AUDC0
	LDA #28
	STA AUDF0
.L097 ;  return

	RTS
.
 ; 

.playvinesecondsound
 ; playvinesecondsound

.L098 ;  AUDV0 = 4 : AUDC0 = 12 : AUDF0 = 20

	LDA #4
	STA AUDV0
	LDA #12
	STA AUDC0
	LDA #20
	STA AUDF0
.L099 ;  return

	RTS
.
 ; 

.playdeathsound
 ; playdeathsound

.L0100 ;  AUDV1 = 4 : AUDC1 = 14 : AUDF1 = 20

	LDA #4
	STA AUDV1
	LDA #14
	STA AUDC1
	LDA #20
	STA AUDF1
.L0101 ;  return

	RTS
.
 ; 

.playvictorysound
 ; playvictorysound

.L0102 ;  AUDV1 = 4 : AUDC1 = 4 : AUDF1 = 10

	LDA #4
	STA AUDV1
	STA AUDC1
	LDA #10
	STA AUDF1
.L0103 ;  return

	RTS
.
 ; 

.stopvoicezero
 ; stopvoicezero

.L0104 ;  AUDV0 = 0

	LDA #0
	STA AUDV0
.L0105 ;  return

	RTS
.
 ; 

.stopvoiceone
 ; stopvoiceone

.L0106 ;  AUDV1 = 0

	LDA #0
	STA AUDV1
.L0107 ;  return

	RTS
.
 ; 

.L0108 ;  rem ===========================================

.L0109 ;  rem =============== DRAW PLAYER ===============

.L0110 ;  rem ===========================================

.drawplayer
 ; drawplayer

.L0111 ;  if playerframe  =  0 then player0:

	LDA playerframe
	CMP #0
     BNE .skipL0111
.condpart16
	LDA #<player16then_0

	STA player0pointerlo
	LDA #>player16then_0

	STA player0pointerhi
	LDA #8
	STA player0height
.skipL0111
.L0112 ;  if playerframe  =  10 then player0:

	LDA playerframe
	CMP #10
     BNE .skipL0112
.condpart17
	LDA #<player17then_0

	STA player0pointerlo
	LDA #>player17then_0

	STA player0pointerhi
	LDA #8
	STA player0height
.skipL0112
.L0113 ;  return

	RTS
.
 ; 

.drawplayerparachute
 ; drawplayerparachute

.L0114 ;  player0:

	LDA #<playerL0114_0

	STA player0pointerlo
	LDA #>playerL0114_0

	STA player0pointerhi
	LDA #16
	STA player0height
.L0115 ;  return

	RTS
.
 ; 

.drawplayerbeingeaten
 ; drawplayerbeingeaten

.L0116 ;  player0:

	LDA #<playerL0116_0

	STA player0pointerlo
	LDA #>playerL0116_0

	STA player0pointerhi
	LDA #8
	STA player0height
.L0117 ;  return

	RTS
.
 ; 

.L0118 ;  rem =================================

.L0119 ;  rem ====== MAIN GAME LOOP ===========

.L0120 ;  rem =================================

.main
 ; main

.
 ; 

.L0121 ;  rem GAME OVER?

.L0122 ;  if life  =  0 then goto showintro

	LDA life
	CMP #0
     BNE .skipL0122
.condpart18
 jmp .showintro

.skipL0122
.
 ; 

.L0123 ;  rem SET VINE FRAME GRAPHICS

.L0124 ;  gosub swingvine

 jsr .swingvine

.
 ; 

.L0125 ;  rem SET SNAPPY FRAME GRAPHICS

.L0126 ;  gosub animatesnappy

 jsr .animatesnappy

.
 ; 

.L0127 ;  rem SET PLAYER FRAME GRAPHICS

.L0128 ;  if gamestate  =  1 then gosub drawplayerparachute

	LDA gamestate
	CMP #1
     BNE .skipL0128
.condpart19
 jsr .drawplayerparachute

.skipL0128
.L0129 ;  if gamestate  =  8 then gosub drawplayerbeingeaten

	LDA gamestate
	CMP #8
     BNE .skipL0129
.condpart20
 jsr .drawplayerbeingeaten

.skipL0129
.L0130 ;  if gamestate  <>  1  &&  gamestate  <>  8 then gosub drawplayer

	LDA gamestate
	CMP #1
     BEQ .skipL0130
.condpart21
	LDA gamestate
	CMP #8
     BEQ .skip21then
.condpart22
 jsr .drawplayer

.skip21then
.skipL0130
.
 ; 

.L0131 ;  rem ADVANCE FRAMES

.L0132 ;  frame = frame + 1

	INC frame
.L0133 ;  playerframe = playerframe + 1

	INC playerframe
.L0134 ;  snappyframe = snappyframe + 1

	INC snappyframe
.
 ; 

.L0135 ;  rem SNAPPY CHOMPS FASTER WHEN HE'S EATING THE PLAYER!!

.L0136 ;  if gamestate  =  8 then snappyframe = snappyframe + 1

	LDA gamestate
	CMP #8
     BNE .skipL0136
.condpart23
	INC snappyframe
.skipL0136
.
 ; 

.L0137 ;  rem APPLY BOUND TO FRAMES

.L0138 ;  if playerframe  >=  20 then playerframe = 0

	LDA playerframe
	CMP #20
     BCC .skipL0138
.condpart24
	LDA #0
	STA playerframe
.skipL0138
.L0139 ;  if frame >= 120 then frame = 0

	LDA frame
	CMP #120
     BCC .skipL0139
.condpart25
	LDA #0
	STA frame
.skipL0139
.L0140 ;  if snappyframe  >=  20 then snappyframe = 0

	LDA snappyframe
	CMP #20
     BCC .skipL0140
.condpart26
	LDA #0
	STA snappyframe
.skipL0140
.
 ; 

.L0141 ;  rem CALCULATE NEW PLAYER POSITION, ENFORCE GAME RULES, ETC.

.L0142 ;  gosub handlestate

 jsr .handlestate

.
 ; 

.L0143 ;  COLUP1  =  206

	LDA #206
	STA COLUP1
.L0144 ;  COLUP0  =  28

	LDA #28
	STA COLUP0
.L0145 ;  COLUBK  =  192

	LDA #192
	STA COLUBK
.L0146 ;  COLUPF  =  88

	LDA #88
	STA COLUPF
.
 ; 

.L0147 ;  rem PERFORM ACTUAL RENDERING

.L0148 ;  drawscreen

 jsr drawscreen
.
 ; 

.L0149 ;  rem BACK TO BEGINNING OF GAME LOOP

.L0150 ;  goto main

 jmp .main

.
 ; 

.L0151 ;  rem =========================================

.L0152 ;  rem = HANDLE GAME STATES BY MOVING PLAYER ===

.L0153 ;  rem = CHECKING GAME RULES AND STATE CHANGES =

.L0154 ;  rem =========================================

.handlestate
 ; handlestate

.L0155 ;  if gamestate  =  6 then gosub createplayer  :  return

	LDA gamestate
	CMP #6
     BNE .skipL0155
.condpart27
 jsr .createplayer
	RTS
.skipL0155
.L0156 ;  if gamestate  =  1 then gosub dropplayer  :  return

	LDA gamestate
	CMP #1
     BNE .skipL0156
.condpart28
 jsr .dropplayer
	RTS
.skipL0156
.L0157 ;  if gamestate  =  2 then gosub playerwaiting  :  return

	LDA gamestate
	CMP #2
     BNE .skipL0157
.condpart29
 jsr .playerwaiting
	RTS
.skipL0157
.L0158 ;  if gamestate  =  3 then gosub playerrunning  :  return

	LDA gamestate
	CMP #3
     BNE .skipL0158
.condpart30
 jsr .playerrunning
	RTS
.skipL0158
.L0159 ;  if gamestate  =  4 then gosub playeronvine  :  return

	LDA gamestate
	CMP #4
     BNE .skipL0159
.condpart31
 jsr .playeronvine
	RTS
.skipL0159
.L0160 ;  if gamestate  =  7 then gosub playerdying  :  return

	LDA gamestate
	CMP #7
     BNE .skipL0160
.condpart32
 jsr .playerdying
	RTS
.skipL0160
.L0161 ;  if gamestate  =  5 then gosub playerruntosafety  :  return

	LDA gamestate
	CMP #5
     BNE .skipL0161
.condpart33
 jsr .playerruntosafety
	RTS
.skipL0161
.L0162 ;  if gamestate  =  8 then gosub snappyeating  :  return

	LDA gamestate
	CMP #8
     BNE .skipL0162
.condpart34
 jsr .snappyeating
	RTS
.skipL0162
.L0163 ;  return

	RTS
.
 ; 

.snappyeating
 ; snappyeating

.L0164 ;  snappyeatingframe  =  snappyeatingframe  +  1

	INC snappyeatingframe
.L0165 ;  playerframe = 0

	LDA #0
	STA playerframe
.L0166 ;  if snappyeatingframe  =  60 then gosub stopvoiceone  :  gamestate  =  6  :  life = life - 1

	LDA snappyeatingframe
	CMP #60
     BNE .skipL0166
.condpart35
 jsr .stopvoiceone
	LDA #6
	STA gamestate
	DEC life
.skipL0166
.L0167 ;  return

	RTS
.
 ; 

.playerdying
 ; playerdying

.L0168 ;  player0y  =  player0y  +  1

	INC player0y
.L0169 ;  if player0y  =  74 then gamestate  =  8  :  gosub playdeathsound

	LDA player0y
	CMP #74
     BNE .skipL0169
.condpart36
	LDA #8
	STA gamestate
 jsr .playdeathsound

.skipL0169
.L0170 ;  return

	RTS
.
 ; 

.playerruntosafety
 ; playerruntosafety

.L0171 ;  player0x  =  player0x  +  1

	INC player0x
.
 ; 

.L0172 ;  rem REACHED SAFETY AT THE END OF SCREEN

.L0173 ;  if player0x  =  139 then gamestate  =  6  :  score  =  score  +  1  :  gosub stopvoiceone  :  life = life - 1

	LDA player0x
	CMP #139
     BNE .skipL0173
.condpart37
	LDA #6
	STA gamestate
	SED
	CLC
	LDA score+2
	ADC #$01
	STA score+2
	LDA score+1
	ADC #$00
	STA score+1
	LDA score
	ADC #$00
	STA score
	CLD
 jsr .stopvoiceone
	DEC life
.skipL0173
.L0174 ;  return

	RTS
.
 ; 

.playeronvine
 ; playeronvine

.L0175 ;  if frame  =  20 then player0x  =  98

	LDA frame
	CMP #20
     BNE .skipL0175
.condpart38
	LDA #98
	STA player0x
.skipL0175
.L0176 ;  if frame  =  30 then player0x  =  106

	LDA frame
	CMP #30
     BNE .skipL0176
.condpart39
	LDA #106
	STA player0x
.skipL0176
.L0177 ;  if frame  =  40 then player0x  =  111

	LDA frame
	CMP #40
     BNE .skipL0177
.condpart40
	LDA #111
	STA player0x
.skipL0177
.L0178 ;  if frame  =  50 then player0x  =  116

	LDA frame
	CMP #50
     BNE .skipL0178
.condpart41
	LDA #116
	STA player0x
.skipL0178
.L0179 ;  if frame  =  60 then player0x  =  121

	LDA frame
	CMP #60
     BNE .skipL0179
.condpart42
	LDA #121
	STA player0x
.skipL0179
.
 ; 

.L0180 ;  rem REACHED THE OTHER SIDE OF THE PIT

.L0181 ;  if frame  =  60 then gamestate  =  5  :  gosub playvictorysound

	LDA frame
	CMP #60
     BNE .skipL0181
.condpart43
	LDA #5
	STA gamestate
 jsr .playvictorysound

.skipL0181
.
 ; 

.L0182 ;  return

	RTS
.
 ; 

.playerrunning
 ; playerrunning

.L0183 ;  player0x  =  player0x  +  1

	INC player0x
.L0184 ;  rem CHECK WHETHER THE PLAYER CATCHES THE VINE WHEN HE REACHES END OF PIT

.L0185 ;  if player0x  =  90 then gosub didplayercatchvine

	LDA player0x
	CMP #90
     BNE .skipL0185
.condpart44
 jsr .didplayercatchvine

.skipL0185
.L0186 ;  return

	RTS
.
 ; 

.didplayercatchvine
 ; didplayercatchvine

.L0187 ;  rem DID PLAYER CATCH VINE? IF NOT, THEN ENTER DYING STATE, AND MOVE SNAPPY UNDERNEATH PLAYER

.L0188 ;  if frame  <=  10  ||  frame  >=  115 then gamestate  =  4 else gamestate  =  7  :  player1x  =  90

	LDA #10
	CMP frame
     BCC .skipL0188
.condpart45
 jmp .condpart46
.skipL0188
	LDA frame
	CMP #115
     BCC .skip6OR
.condpart46
	LDA #4
	STA gamestate
 jmp .skipelse1
.skip6OR
	LDA #7
	STA gamestate
	LDA #90
	STA player1x
.skipelse1
.L0189 ;  return

	RTS
.
 ; 

.playerwaiting
 ; playerwaiting

.L0190 ;  rem WE DON'T WANT THE PLAYER ANIMATING, SO WE'LL JUST KEEP HIS

.L0191 ;  rem ANIMATION FRAME AT 0

.L0192 ;  playerframe  =  0

	LDA #0
	STA playerframe
.
 ; 

.L0193 ;  rem IF FIRE IS PRESSED, PUT PLAYER IN RUNNING MODE

.L0194 ;  if joy0fire then gamestate  =  3

 lda #$80
 bit INPT4
	BNE .skipL0194
.condpart47
	LDA #3
	STA gamestate
.skipL0194
.L0195 ;  return

	RTS
.
 ; 

.dropplayer
 ; dropplayer

.L0196 ;  player0y  =  player0y  +  1

	INC player0y
.L0197 ;  rem DID PLAYER REACH GROUND?

.L0198 ;  if player0y  =  56 then gamestate  =  2

	LDA player0y
	CMP #56
     BNE .skipL0198
.condpart48
	LDA #2
	STA gamestate
.skipL0198
.
 ; 

.L0199 ;  rem WE DON'T WANT THE PLAYER ANIMATING, SO WE'LL JUST KEEP HIS

.L0200 ;  rem ANIMATION FRAME AT 0

.L0201 ;  playerframe  =  0

	LDA #0
	STA playerframe
.L0202 ;  return

	RTS
.
 ; 

.createplayer
 ; createplayer

.L0203 ;  rem SPAWN PLAYER

.L0204 ;  player0x  =  20  +   ( rand  /  4 ) 

; complex statement detected
	LDA #20
	PHA
 jsr randomize
	lsr
	lsr
	TSX
	INX
	TXS
	CLC
	ADC $100,x
	STA player0x
.L0205 ;  player0y  =  10

	LDA #10
	STA player0y
.L0206 ;  gamestate  =  1

	LDA #1
	STA gamestate
.L0207 ;  playerframe  =  0

	LDA #0
	STA playerframe
.
 ; 

.L0208 ;  rem RESET SNAPPY

.L0209 ;  player1x  =  102

	LDA #102
	STA player1x
.L0210 ;  player1y  =  80

	LDA #80
	STA player1y
.L0211 ;  snappyeatingframe  =  0

	LDA #0
	STA snappyeatingframe
.L0212 ;  return

	RTS
 if (<*) > (<(*+12))
	repeat ($100-<*)
	.byte 0
	repend
	endif
player2then_1

	.byte 0
	.byte    %00111100
	.byte    %00111100
	.byte    %00111100
	.byte    %00111100
	.byte    %01100111
	.byte    %01100110
	.byte    %01100110
	.byte    %11000011
	.byte    %11000011
	.byte    %11000011
	.byte    %10000001
 if (<*) > (<(*+12))
	repeat ($100-<*)
	.byte 0
	repend
	endif
player3then_1

	.byte 0
	.byte    %00111100
	.byte    %00111100
	.byte    %00111100
	.byte    %00111100
	.byte    %00111110
	.byte    %00111100
	.byte    %00111100
	.byte    %00111100
	.byte    %00011100
	.byte    %00011100
	.byte    %00011000
 if (<*) > (<(*+9))
	repeat ($100-<*)
	.byte 0
	repend
	endif
player16then_0

	.byte 0
	.byte         %00110110
	.byte         %00100100
	.byte         %00100100
	.byte         %00011000
	.byte         %01111110
	.byte         %00011000
	.byte         %00111100
	.byte         %00111100
 if (<*) > (<(*+9))
	repeat ($100-<*)
	.byte 0
	repend
	endif
player17then_0

	.byte 0
	.byte         %00011100
	.byte         %00011000
	.byte         %00011000
	.byte         %00011010
	.byte         %00111100
	.byte         %01011000
	.byte         %00111100
	.byte         %00111100
 if (<*) > (<(*+17))
	repeat ($100-<*)
	.byte 0
	repend
	endif
playerL0114_0

	.byte 0
	.byte         %00110110
	.byte         %00100100
	.byte         %00100100
	.byte         %00011000
	.byte         %00111100
	.byte         %01011010
	.byte         %01111110
	.byte         %01111110
	.byte 		%00100100
	.byte 		%00100100
	.byte 		%01000010
	.byte 		%10000001
	.byte 		%11111111
	.byte 		%11111111
	.byte 		%01111110
	.byte 		%00111100
 if (<*) > (<(*+9))
	repeat ($100-<*)
	.byte 0
	repend
	endif
playerL0116_0

	.byte 0
	.byte 		%00000000
	.byte         %00000000
	.byte         %00000000
	.byte         %00000000
	.byte         %00011110
	.byte         %00011000
	.byte         %00111100
	.byte         %00111100
       echo "    ",[(scoretable - *)]d , "bytes of ROM space left")
 
 
 
; feel free to modify the score graphics - just keep each digit 8 high
; and keep the conditional compilation stuff intact
 ifconst ROM2k
   ORG $F7AC
 else
   ifconst bankswitch
     if bankswitch == 8
       ORG $2F94-bscode_length
       RORG $FF94-bscode_length
     endif
     if bankswitch == 16
       ORG $4F94-bscode_length
       RORG $FF94-bscode_length
     endif
     if bankswitch == 32
       ORG $8F94-bscode_length
       RORG $FF94-bscode_length
     endif
   else
     ORG $FF9C
   endif
 endif


scoretable
       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100

       .byte %01111110
       .byte %00011000
       .byte %00011000
       .byte %00011000
       .byte %00011000
       .byte %00111000
       .byte %00011000
       .byte %00001000

       .byte %01111110
       .byte %01100000
       .byte %01100000
       .byte %00111100
       .byte %00000110
       .byte %00000110
       .byte %01000110
       .byte %00111100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00000110
       .byte %00011100
       .byte %00000110
       .byte %01000110
       .byte %00111100

       .byte %00001100
       .byte %00001100
       .byte %01111110
       .byte %01001100
       .byte %01001100
       .byte %00101100
       .byte %00011100
       .byte %00001100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00000110
       .byte %00111100
       .byte %01100000
       .byte %01100000
       .byte %01111110

       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01111100
       .byte %01100000
       .byte %01100010
       .byte %00111100

       .byte %00110000
       .byte %00110000
       .byte %00110000
       .byte %00011000
       .byte %00001100
       .byte %00000110
       .byte %01000010
       .byte %00111110

       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %00111100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00111110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100 


 ifconst ROM2k
   ORG $F7FC
 else
   ifconst bankswitch
     if bankswitch == 8
       ORG $2FF4-bscode_length
       RORG $FFF4-bscode_length
     endif
     if bankswitch == 16
       ORG $4FF4-bscode_length
       RORG $FFF4-bscode_length
     endif
     if bankswitch == 32
       ORG $8FF4-bscode_length
       RORG $FFF4-bscode_length
     endif
   else
     ORG $FFFC
   endif
 endif
 ifconst bankswitch
   if bankswitch == 8
     ORG $2FFC
     RORG $FFFC
   endif
   if bankswitch == 16
     ORG $4FFC
     RORG $FFFC
   endif
   if bankswitch == 32
     ORG $8FFC
     RORG $FFFC
   endif
 else
   ifconst ROM2k
     ORG $F7FC
   else
     ORG $FFFC
   endif
 endif
 .word start
 .word start
